#include "stdafx.h"
#include <d3d8.h>
#include <d3dx8.h>
#include <dxfile.h>
#include "GameMain.h"
#include <rmxftmpl.h>
#include <rmxfguid.h>
#include "XFrame.h"

//---------------------------------------------------------------
//	Name: GetFileName
//	Desc: t@C̃pXăt@Ĉ݂ƂB
//---------------------------------------------------------------
static void	GetFileName(TCHAR *str)
{
	int	l,i;
	l = strlen(str);
	if ((str[0]=='\"')&&(str[l-1]=='\"')){
		for(i = 0; i < (l - 1) ; ++i){
			str[i] = str[i+1];
		}
		--l;
		str[l] = 0;
	}
	while(l){
		if (str[l]=='\\'){
			i = 0;
			while(str[i++] = str[++l]);
			return;
		}
		--l;
	}
}

//---------------------------------------------------
//	Name: CXFrame
//	Desc: RXgN^
//---------------------------------------------------
CXFrame::CXFrame()
{
	next = NULL;
	m_frameNode = NULL;
	m_meshNode = NULL;
	D3DXMatrixIdentity(&m_matFrame);
};

//---------------------------------------------------
//	Name: ~CXFrame
//	Desc: fXgN^
//---------------------------------------------------
CXFrame::~CXFrame(){
	CXFrame	*tmp,*next;
	tmp = m_frameNode;
	while(tmp){
		next = tmp->next;
		delete tmp;
		tmp = next;
	}
	m_frameNode = NULL;
	CXMeshNode	*tmpMesh,*nextMesh;
	tmpMesh = m_meshNode;
	while(tmpMesh){
		nextMesh = tmpMesh->next;
		TRACE("Mesh deleted\n");
	    SAFE_DELETE_ARRAY( tmpMesh->m_ppTextures );
		SAFE_RELEASE( tmpMesh->m_pMeshEnhanced);
		SAFE_RELEASE( tmpMesh->m_pMeshSysMem );
		SAFE_RELEASE( tmpMesh->m_pbufAdjacency);
		SAFE_RELEASE( tmpMesh->m_pbufMaterials );
		delete	tmpMesh;
		tmpMesh = nextMesh;
	}
	m_meshNode = NULL;
}

//------------------------------------------------------------------------
//	Name: DeleteDeviceObjects
//	Desc: foCXˑIuWFNg̔jBCXFrame ̃[g͍폜ȂB
//------------------------------------------------------------------------
HRESULT CXFrame::DeleteDeviceObjects(){
	CXFrame	*tmp,*next;
	tmp = m_frameNode;
	while(tmp){
		next = tmp->next;
		delete tmp;
		tmp = next;
	}
	m_frameNode = NULL;
	CXMeshNode	*tmpMesh,*nextMesh;
	tmpMesh = m_meshNode;
	while(tmpMesh){
		nextMesh = tmpMesh->next;
		TRACE("Mesh deleted\n");
	    SAFE_DELETE_ARRAY( tmpMesh->m_ppTextures );
		SAFE_RELEASE( tmpMesh->m_pMeshEnhanced);
		SAFE_RELEASE( tmpMesh->m_pMeshSysMem );
		SAFE_RELEASE( tmpMesh->m_pbufAdjacency);
		SAFE_RELEASE( tmpMesh->m_pbufMaterials );
		delete	tmpMesh;
		tmpMesh = nextMesh;
	}
	m_meshNode = NULL;
	return	S_OK;
}

//================================================================
// Name: AdjustPositions
// Desc: ebV̈ʒuETCYXVB
//		G[ɖ肠B
//================================================================
void CXFrame::AdjustPositions(LPDIRECT3DDEVICE8 lpd3ddev, D3DXMATRIX *matParent){
	D3DXMATRIX	matTransCur;

	matTransCur = this->m_matFrame * (*matParent);
	CXFrame	*tmp, *next;
	tmp = m_frameNode;
	while(tmp){
		next = tmp->next;
		tmp->AdjustPositions(lpd3ddev, &matTransCur);
		tmp = next;
	}

	CXMeshNode	*tmpMesh;
	tmpMesh = m_meshNode;
    LPDIRECT3DVERTEXBUFFER8 pVB = NULL;
	D3DXVECTOR4	vecOut;
    BYTE*		pVertices = NULL;
	HRESULT		hr;
	for( tmpMesh = m_meshNode; tmpMesh != NULL; tmpMesh = tmpMesh->next){

		// vertex buffer, bNB
		if (tmpMesh->m_pMeshSysMem == NULL)
			continue;
		hr = tmpMesh->m_pMeshSysMem->GetVertexBuffer( &pVB );
		if( FAILED(hr) )
			continue;

		hr = pVB->Lock( 0, 0, &pVertices, 0 );
		if( FAILED(hr) )
		{
			SAFE_RELEASE( pVB );
			continue;
		}
		hr = D3DXComputeBoundingSphere( pVertices, tmpMesh->m_pMeshSysMem->GetNumVertices(), 
										tmpMesh->m_pMeshSysMem->GetFVF(), &tmpMesh->m_vObjectCenterOrg, 
										&tmpMesh->m_fObjectRadius );
		D3DXVec3Transform(&vecOut,&tmpMesh->m_vObjectCenterOrg,&matTransCur);
		tmpMesh->m_vObjectCenter = (D3DXVECTOR3)vecOut;
		if( FAILED(hr) )
		{
			pVB->Unlock();
			SAFE_RELEASE( pVB );
			continue;
		}

		pVB->Unlock();
		SAFE_RELEASE( pVB );
	}
}

//=============================================================
//	Name: ReverseItems
//	Desc: qt[ƃbVXg̏𔽓]B
//=============================================================
void CXFrame::ReverseItems(){
	CXFrame	*tmp = this->m_frameNode,*next;
	this->m_frameNode = NULL;
	while(tmp){
		next = tmp->next;
		tmp->next = this->m_frameNode;
		this->m_frameNode = tmp;
		tmp = next;
	}
	//	bV̓ւ
	CXMeshNode *tmpMesh = this->m_meshNode, * nextMesh;
	this->m_meshNode = NULL;
	while(tmpMesh){
		nextMesh = tmpMesh->next;
		tmpMesh->next = this->m_meshNode;
		this->m_meshNode = tmpMesh;
		tmpMesh = nextMesh;
	}
}

//===============================================================
//	Name: LoadFrameItem
//	Desc: Frame ɓǂݍ܂ׂAmatrix  
//			P͕ mesh ǂݍ
//===============================================================
HRESULT CXFrame::LoadFrameItem(LPDIRECT3DDEVICE8 lpd3ddev, LPDIRECTXFILEDATA pxofdata, const GUID *type)
{
	HRESULT	hr;
	if (*type == TID_D3DRMFrameTransformMatrix){
		DWORD	cbSize;
		D3DXMATRIX	*pmat;
        hr = pxofdata->GetData(NULL, &cbSize, (PVOID*)&pmat);
        if (FAILED(hr)){
			D3DXMatrixIdentity(&this->m_matFrame);
			return hr;
		}
		this->m_matFrame = *pmat;
	}else if (*type == TID_D3DRMMesh){
		CXMeshNode	*tmpMesh = NULL;
		tmpMesh = new CXMeshNode(this);
		hr = D3DXLoadMeshFromXof(pxofdata,D3DXMESH_SYSTEMMEM,lpd3ddev,
			&tmpMesh->m_pbufAdjacency, &tmpMesh->m_pbufMaterials, &tmpMesh->m_dwNumMaterials, 
			&tmpMesh->m_pMeshSysMem );
		if (FAILED(hr)){
			tmpMesh->m_pMeshSysMem = NULL;
			delete	tmpMesh;
		}else{
			tmpMesh->next = this->m_meshNode;
			this->m_meshNode = tmpMesh;
			tmpMesh->m_pMaterials 
				= (D3DXMATERIAL*)tmpMesh->m_pbufMaterials->GetBufferPointer();
			tmpMesh->m_ppTextures 
				= new LPDIRECT3DTEXTURE8[tmpMesh->m_dwNumMaterials];
			ZeroMemory(tmpMesh->m_ppTextures,sizeof(LPDIRECT3DTEXTURE8)*tmpMesh->m_dwNumMaterials);
			// _tH[}bg̏CE@K{ƂB
			if( !(tmpMesh->m_pMeshSysMem->GetFVF() & D3DFVF_NORMAL) )
			{
			    LPD3DXMESH pTempMesh;
				hr = tmpMesh->m_pMeshSysMem->CloneMeshFVF( tmpMesh->m_pMeshSysMem->GetOptions(), 
												  tmpMesh->m_pMeshSysMem->GetFVF() | D3DFVF_NORMAL, 
												  lpd3ddev, &pTempMesh );
				if( SUCCEEDED(hr) ){
#if	D3D_SDK_VERSION >= 200
					D3DXComputeNormals( pTempMesh, NULL );
#else
					D3DXComputeNormals( pTempMesh );
#endif
					SAFE_RELEASE( tmpMesh->m_pMeshSysMem );
					tmpMesh->m_pMeshSysMem = pTempMesh;
				}
			}		
		}
	}else if (*type == TID_D3DRMMaterial){
		TRACE("Material (outside a mesh) Found.\n");
		TRACE("{%x-%x-%x-%x}\n",type->Data1,type->Data2,type->Data3,type->Data4);
	}else{
		TRACE("This is not supported yet.\n");
		TRACE("{%x-%x-%x-%x}\n",type->Data1,type->Data2,type->Data3,type->Data4);
	}
	return S_OK;
}

//==============================================================================
//	Name: LoadFrames
//  Desc: CX^X[gt[Ƃ݂ȂāAbVc[B
//==============================================================================
HRESULT CXFrame::LoadFrames(LPDIRECT3DDEVICE8 lpd3ddev,LPDIRECTXFILEENUMOBJECT pxofenum)
{
//	DirectX ̃TvƂ͈قȂAċA͎gȂB
//	iG[ȗɂׁj
	LPDIRECTXFILEOBJECT pxofobject = NULL;
    LPDIRECTXFILEDATA pxofobjdata = NULL;
	LPDIRECTXFILEDATA pxofdata = NULL;
	LPDIRECTXFILEDATA tmpdata = NULL;
	CXFrame	*newframe = NULL;
    const GUID *type=NULL;
	DWORD	len;
	LPSTR	buf = NULL;
	HRESULT	hr;
	struct	{
		CXFrame *pFrame;
		LPDIRECTXFILEDATA	pData;
	}	stack[CXFRAME_NEST_DEPTH];
	int	sp = 0;

	ZeroMemory((void*)stack,sizeof(stack));
	while(SUCCEEDED(hr = pxofenum->GetNextDataObject(&pxofdata))){
		pxofdata->GetType(&type);
		pxofdata->GetName(NULL,&len);
		if (len > 0){
			buf = (LPSTR)new char[len];
			pxofdata->GetName(buf,&len);
			TRACE("name:%s\n",buf);
			delete buf;
		}
		if (*type == TID_D3DRMFrame){
			newframe = new CXFrame();
			this->addChild(newframe);
			stack[sp].pFrame = newframe;
			stack[sp].pData = pxofdata;
			while(true){
				if (SUCCEEDED(stack[sp].pData->GetNextObject(&pxofobject))){
					hr = pxofobject->QueryInterface(IID_IDirectXFileData,(LPVOID*)&tmpdata);
					SAFE_RELEASE(pxofobject);
					if (FAILED(hr)){
						continue;
					}
					tmpdata->GetType(&type);
					tmpdata->GetName(NULL,&len);
					if (*type == TID_D3DRMFrame){
						if ((sp >= (CXFRAME_NEST_DEPTH-1))	//	X^bNI[o[
							|| (NULL == (newframe = new CXFrame()))){
							SAFE_RELEASE(tmpdata);
							while(sp){
								SAFE_RELEASE(stack[sp].pData);
								stack[sp].pFrame = NULL;
								--sp;
							}
							return	hr;
						}
						stack[sp].pFrame->addChild(newframe);
						stack[++sp].pFrame = newframe;
						stack[sp].pData = tmpdata;
						newframe = NULL;
						tmpdata = NULL;
						continue;
					}else{
						stack[sp].pFrame->LoadFrameItem(lpd3ddev,tmpdata,type);
					}
					SAFE_RELEASE(tmpdata);
				}else{
					stack[sp].pFrame->ReverseItems();
					if (sp == 0){
						stack[sp].pFrame = NULL;
						stack[sp].pData = NULL;
						break;
					}else{
						tmpdata = stack[sp].pData;
						stack[sp].pFrame = NULL;
						stack[sp].pData = NULL;
						--sp;
					}
				}
			}
		}else{
			this->LoadFrameItem(lpd3ddev,pxofdata,type);
			TRACE("Some global item was found\n");
		}			
		SAFE_RELEASE(pxofdata);
	}
	return	S_OK;
}

//===========================================================
//	Name: InitDeviceObjects
//	Desc: foCXˑIuWFNg̏
//===========================================================
HRESULT	CXFrame::InitDeviceObjects(LPDIRECT3DDEVICE8 lpd3ddev, DXFILELOADRESOURCE *res)
{
    HRESULT    hr;

	this->InvalidateFrameDeviceObjects();
	this->DeleteDeviceObjects();
    LPDIRECTXFILE pxofapi = NULL;
    LPDIRECTXFILEENUMOBJECT pxofenum = NULL;
	hr = DirectXFileCreate(&pxofapi);
    const GUID *type=NULL;
	LPSTR	buf = NULL;
	hr = pxofapi->RegisterTemplates(D3DRM_XTEMPLATES,D3DRM_XTEMPLATE_BYTES);
	if (FAILED(hr)){
		return	E_FAIL;
	}
	hr = pxofapi->CreateEnumObject((LPVOID)res,DXFILELOAD_FROMRESOURCE,&pxofenum);
	if (FAILED(hr)){
		SAFE_RELEASE(pxofenum);
		return	E_FAIL;
	}
	hr = this->LoadFrames(lpd3ddev,pxofenum);
	if (FAILED(hr)){
		SAFE_RELEASE(pxofenum);
		SAFE_RELEASE(pxofapi);
		this->InvalidateFrameDeviceObjects();
		this->DeleteDeviceObjects();
		return	E_FAIL;
	}
	SAFE_RELEASE(pxofenum);
	SAFE_RELEASE(pxofapi);
	return	S_OK;
}


//===================================================================
// Name: RestoreMeshObjects
// Desc: RestoreFrameDeviceObjects gpB
//===================================================================
HRESULT	CXFrame::RestoreMeshObjects(LPDIRECT3DDEVICE8 lpd3ddev,DWORD dwNumSegs, BOOL bUseHWNPatches)
{
	D3DCAPS8	d3dCaps;
	HRESULT		hr;
	lpd3ddev->GetDeviceCaps(&d3dCaps);
	CXMeshNode	*tmpMesh,*nextMesh;
	tmpMesh = this->m_meshNode;
	while(tmpMesh){
		nextMesh = tmpMesh->next;
		//	eNX`̓ǂݍ
		for( UINT i=0; i<tmpMesh->m_dwNumMaterials; i++ )
		{
			TCHAR tmp[128];
			if (tmpMesh->m_pMaterials[i].pTextureFilename){
				_tcscpy( tmp, tmpMesh->m_pMaterials[i].pTextureFilename );
				GetFileName(tmp);

				if( FAILED( D3DXCreateTextureFromResource( lpd3ddev, GetModuleHandle(NULL),tmp, 
					&tmpMesh->m_ppTextures[i] ) ) ){
					TRACE("Failed to load texture %s\n",tmp);
					tmpMesh->m_ppTextures[i] = NULL;
				}else{
					TRACE("Texture %s successfully loaded.\n",tmp);
				}
			}
		}

		//	bV̊g
		hr = 
			tmpMesh->GenerateEnhancedMesh(lpd3ddev, dwNumSegs, bUseHWNPatches);
		if (FAILED(hr)){
			return	hr;
		}
		tmpMesh = nextMesh;
	}
	return	S_OK;
}
//===================================================================
// Name: RestoreFrameDeviceObjects()
// Desc: this [gt[Ƃ݂ȂāAfoCXˑIuWFNg
//		ǂݍ݂sB
//===================================================================
HRESULT	CXFrame::RestoreFrameDeviceObjects(LPDIRECT3DDEVICE8 lpd3ddev,DWORD dwNumSegs,BOOL bUseHWNPatches)
{
	CXFrame		*tmp;
	HRESULT		hr;
	struct	{
		CXFrame *pFrame;
		CXFrame *pChild;
	}	stack[CXFRAME_NEST_DEPTH];
	int	sp = 0;
	
	stack[sp].pFrame = this;
	stack[sp].pChild = this->m_frameNode;
	while(true){
		if (tmp = stack[sp].pChild){
			if (++sp >= CXFRAME_NEST_DEPTH){
				TRACE("Stack over\n");
				return	E_FAIL;	//	stack over.
			}
			stack[sp].pFrame = tmp;
			stack[sp].pChild = tmp->m_frameNode;
			continue;
		}
		hr = stack[sp].pFrame->RestoreMeshObjects(lpd3ddev,dwNumSegs,bUseHWNPatches);
		if (FAILED(hr)){
			TRACE("Couldn't Restore\n");
			return hr;
		}
		stack[sp].pFrame = NULL;
		if (--sp < 0)
			break;
		stack[sp].pChild = stack[sp].pChild->next;
	}
	return	S_OK;
}

//===================================================================
// Name: InvalidateFrameDeviceObjects()
// Desc: this [gt[ƌȂāAfoCXˑIuWFNg
//		B
//===================================================================
HRESULT	CXFrame::InvalidateFrameDeviceObjects(){
	CXFrame	*tmp,*next;
	tmp = this->m_frameNode;
	while(tmp){
		next = tmp->next;
		tmp->InvalidateFrameDeviceObjects();
		tmp = next;
	}
	CXMeshNode	*tmpMesh,*nextMesh;
	tmpMesh = this->m_meshNode;
	while(tmpMesh){
		nextMesh = tmpMesh->next;
		SAFE_RELEASE(tmpMesh->m_pMeshEnhanced);
		if (tmpMesh->m_ppTextures != NULL){
			for ( UINT i = 0; i < tmpMesh->m_dwNumMaterials;i++){
				SAFE_RELEASE(tmpMesh->m_ppTextures[i]);
			}
		}
		tmpMesh = nextMesh;
	}
	return	S_OK;
}

//-----------------------------------------------------------------------------
// Name: CountNMesh()
// Desc: t[̃bV̑ZoB
//-----------------------------------------------------------------------------
DWORD	CXFrame::CountNMeshes(DWORD current)
{
	CXFrame	*tmp, *next;
	tmp = this->m_frameNode;
	while(tmp){
		next = tmp->next;
		current = tmp->CountNMeshes(current);
		tmp = next;
	}

	CXMeshNode	*tmpMesh,*nextMesh;
	tmpMesh = this->m_meshNode;
	while(tmpMesh){
		nextMesh = tmpMesh->next;
		if (tmpMesh->m_pMeshSysMem)
			current++;
		tmpMesh = nextMesh;
	}
	return	current;
}
//-----------------------------------------------------------------------------
// Name: CountNFrame()
// Desc: t[̃bV̑ZoB
//-----------------------------------------------------------------------------
DWORD	CXFrame::CountNFrames(DWORD current)
{
	CXFrame	*tmp, *next;
	tmp = this->m_frameNode;
	while(tmp){
		next = tmp->next;
		current = tmp->CountNFrames(current);
		tmp = next;
	}
	current++;
	return	current;
}

//-----------------------------------------------------------------------------
// Name: SearchMeshByTexName()
// Desc: w肳ꂽÕeNX`gpĂBMesh B
//-----------------------------------------------------------------------------
CXMeshNode	*CXFrame::SearchMeshByTexName(LPSTR name, DWORD dwNumFrame)
{
	CXMeshNode *pRet = NULL;
	CXFrame		**pStack = NULL;
	CXFrame		*tmpFrame;
	CXMeshNode	*tmpMeshNode;
	DWORD		sp = 0;
	UINT		i;
	TCHAR		tmpStr[128];

	pStack = (CXFrame**)new LPVOID[dwNumFrame+1];
	if (pStack == NULL){
		TRACE("Low memory.\n");
		return	NULL;
	}
	pStack[sp++] = this;
	while(sp>0){
		tmpFrame=pStack[--sp];
		tmpMeshNode = tmpFrame->m_meshNode;
		while(tmpMeshNode){
			for (i = 0; i < tmpMeshNode->m_dwNumMaterials ; ++i){
				strcpy(tmpStr,tmpMeshNode->m_pMaterials[i].pTextureFilename);
				GetFileName(tmpStr);
				if (0==strcmp(name,tmpStr)){
					pRet = tmpMeshNode;
					goto END_OF_SEARCH;		
				}
			}
			tmpMeshNode = tmpMeshNode->next;
		}
		tmpFrame = tmpFrame->m_frameNode;
		while(tmpFrame){
			pStack[sp++] = tmpFrame;
			tmpFrame = tmpFrame->next;
		}
	}
END_OF_SEARCH:
	delete	pStack;
	return	pRet;
}

//-----------------------------------------------------------------------------
// Name: RenderFrames()
// Desc: Kwt[̃_[
//-----------------------------------------------------------------------------
void	CXFrame::RenderFrames(LPDIRECT3DDEVICE8 lpd3ddev,D3DXMATRIX *matTrans, D3DXMATRIX *matParent)
{
	D3DXMATRIX	matTransCur;
	D3DXMATRIX	matMesh;
	D3DXMATRIX	matTmp;

	matTransCur = this->m_matFrame * (*matParent);
	CXFrame		*tmp, *next;
	tmp = this->m_frameNode;
	while(tmp){
		next = tmp->next;
		tmp->RenderFrames(lpd3ddev,matTrans, &matTransCur);
		tmp = next;
	}
	CXMeshNode	*tmpMesh,*nextMesh;
	tmpMesh = this->m_meshNode;
	while(tmpMesh){
		matMesh = (*matTrans);
		lpd3ddev->SetTransform( D3DTS_WORLD, &matMesh );
		nextMesh = tmpMesh->next;
		if (tmpMesh->m_ppTextures != NULL){
			for ( UINT i = 0; i < tmpMesh->m_dwNumMaterials;i++){
				lpd3ddev->SetMaterial( &tmpMesh->m_pMaterials[i].MatD3D );
				lpd3ddev->SetTexture( 0, tmpMesh->m_ppTextures[i] );
				if (tmpMesh->m_pMeshEnhanced)
					tmpMesh->m_pMeshEnhanced->DrawSubset( i );
			}
		}
		tmpMesh = nextMesh;
	}
}


//===================================================================
// Name: GenerateEnhancedMesh()
// Desc: gbV̐A\ȂrfIɐB
//===================================================================
HRESULT CXMeshNode::GenerateEnhancedMesh( LPDIRECT3DDEVICE8 lpd3ddev, UINT dwNewNumSegs, BOOL bUseHWNPatches)
{
    LPD3DXMESH pMeshEnhancedSysMem = NULL;
    LPD3DXMESH pMeshTemp = NULL;
    HRESULT    hr;
	// n[hEFA Tesselation ̏ꍇAPɃRs[邾B
	if (bUseHWNPatches){
		hr = m_pMeshSysMem->CloneMeshFVF( D3DXMESH_WRITEONLY | D3DXMESH_NPATCHES, 
								m_pMeshSysMem->GetFVF(), lpd3ddev, &pMeshTemp );
		if( FAILED(hr) )
			return hr;
	}else{
		if (dwNewNumSegs < 1){	//	|SȂΒPɃRs[
			hr = m_pMeshSysMem->CloneMeshFVF( D3DXMESH_WRITEONLY , 
								m_pMeshSysMem->GetFVF(), lpd3ddev, &pMeshTemp );
			if( FAILED(hr) )
				return hr;
		}else{
#if D3D_SDK_VERSION >= 200
			//	ňU|S
			hr = D3DXTessellateNPatches( m_pMeshSysMem, (DWORD*)m_pbufAdjacency->GetBufferPointer(), 
									(float)dwNewNumSegs, FALSE, &pMeshEnhancedSysMem, NULL );
#else
			hr = D3DXTesselateMesh( m_pMeshSysMem, (DWORD*)m_pbufAdjacency->GetBufferPointer(), 
									(float)dwNewNumSegs, FALSE, &pMeshEnhancedSysMem );
#endif
			if( FAILED(hr) )
				return hr;

			//	ς݂̃bVrfIփRs[B
			hr = pMeshEnhancedSysMem->CloneMeshFVF( D3DXMESH_WRITEONLY, m_pMeshSysMem->GetFVF(),
													lpd3ddev, &pMeshTemp );
			if( FAILED(hr) ){
				SAFE_RELEASE( pMeshEnhancedSysMem );
				return hr;
			}
			//	|Sꂽ̃bV폜
			SAFE_RELEASE( pMeshEnhancedSysMem );
		}
	}
	SAFE_RELEASE( m_pMeshEnhanced );
	m_pMeshEnhanced = pMeshTemp;
    return S_OK;
}

