
#ifndef	__XFRAME_H__
#define	__XFRAME_H__
class	CXFrame;
class	CXMeshNode{
public:
	CXMeshNode(CXFrame *frm){
		parent = frm;
		m_pMeshSysMem = NULL;
		m_pMeshEnhanced = NULL;
		m_dwNumMaterials = 0;
		m_pbufMaterials = NULL;
		m_pbufAdjacency = NULL;
		D3DXMatrixIdentity(&m_matScale);
	};
	HRESULT GenerateEnhancedMesh( LPDIRECT3DDEVICE8 lpd3ddev, UINT dwNewNumSegs,BOOL bUseHWNPatches );
	CXFrame			*parent;
	CXMeshNode		*next;
	D3DXVECTOR3		m_vObjectCenterOrg; // [JWnł̃IuWFNg̒SZo
	D3DXVECTOR3		m_vObjectCenter;    // [gt[Wnł̃IuWFNg̒SZo
	FLOAT			m_fObjectRadius;    // IuWFNg̃oEfBOXtBA̔a
	LPD3DXMESH		m_pMeshSysMem;
	LPD3DXMESH		m_pMeshEnhanced;
	D3DXMATRIX		m_matScale;
	DWORD			m_dwNumMaterials;   // }eA
	LPD3DXBUFFER			m_pbufMaterials;    // }eAobt@
	LPD3DXBUFFER			m_pbufAdjacency;    // Mesh adjacency
	D3DXMATERIAL*			m_pMaterials;       // }eAւ̃|C^
	LPDIRECT3DTEXTURE8*		m_ppTextures;       // eNX`zeNX`ΗvfNULL
};
class	CXFrame{
public:
	CXFrame();
	~CXFrame();
	void addChild(CXFrame *c){
		c->next = m_frameNode;
		m_frameNode = c;
	};
	void	AdjustPositions(LPDIRECT3DDEVICE8 lpd3ddev, D3DXMATRIX *matParent);	//	ebṼoEfBOXtBA𒲐
	void	LoadFrames(LPDIRECT3DDEVICE8 lpd3ddev,LPDIRECTXFILEDATA pxofdata);
	HRESULT	InitDeviceObjects(LPDIRECT3DDEVICE8 lpd3ddev, DXFILELOADRESOURCE *res);
	HRESULT	RestoreFrameDeviceObjects(LPDIRECT3DDEVICE8 lpd3ddev,DWORD dwNumSegs, BOOL bUseHWNPatches);
	HRESULT	InvalidateFrameDeviceObjects();
	HRESULT	DeleteDeviceObjects();
	void	ReverseItems();
	DWORD		CountNMeshes(DWORD current=0);
	DWORD		CountNFrames(DWORD current=0);
	HRESULT		LoadFrames(LPDIRECT3DDEVICE8 lpd3ddev,LPDIRECTXFILEENUMOBJECT pxofenum);
	HRESULT		LoadFrameItem(LPDIRECT3DDEVICE8 lpd3ddev, LPDIRECTXFILEDATA pxofdata, const GUID *type);
	void		RenderFrames(LPDIRECT3DDEVICE8 lpd3ddev, D3DXMATRIX *matTrans, D3DXMATRIX *matParent);
	CXMeshNode	*SearchMeshByTexName(LPSTR name, DWORD dwNumFrames);
private:
	HRESULT RestoreMeshObjects(LPDIRECT3DDEVICE8 lpd3ddev,DWORD dwNumSegs, BOOL bUseHWNPatches);
	CXFrame			*next;
	CXFrame			*m_frameNode;
	CXMeshNode		*m_meshNode;
	D3DXMATRIX		m_matFrame;
	D3DXMATRIX		m_matTrans;
};
#define	CXFRAME_NEST_DEPTH	16

#endif