/*
 *
 *		\tgEFAɂÂ̕\
 *	
 *		First edition:	Nov.07.2001
 *		Author:			Yohei Kishimoto
 *						based on Microsoft's DirectX sample program.
 */

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <crtdbg.h>

#include "resource.h"
#include <largeint.h>
#include <math.h>
#include <time.h>
#include <ddraw.h>
#include "GameMain.h"
#include "Trifunc.h"

//-----------------------------------------------------------------------------
// Global data
//-----------------------------------------------------------------------------
LPDIRECTDRAW4               g_pDD = NULL;        // DirectDraw object
LPDIRECTDRAWSURFACE4        g_pDDSPrimary = NULL;// DirectDraw primary surface
LPDIRECTDRAWSURFACE4		g_pDDSOffScreen = NULL;
LPDIRECTDRAWCLIPPER         g_pClipper = NULL;   // Clipper for primary
LPDIRECTDRAWPALETTE         g_pDDPal = NULL;     // The primary surface palette
LPDIRECTDRAWSURFACE4		g_pDDSOne = NULL;
static char                *szBitmap = NULL;
HWND			g_Hwnd;
LARGE_INTEGER	g_liFrequency;
LARGE_INTEGER	g_liCounter;
LARGE_INTEGER	g_liRemainder;
RECT			g_rcScreen;
DWORD			g_dwEraseColor;
DWORD			g_dwLineColor;

static void	DrawBox(IDirectDrawSurface4 * pdds, long progress);
void	IgnoreTime();

#define	SCREEN_BIT_DEPTH	8
#define	FRAME_RATE	60
void	DestroyThisApp()
{
}

//-----------------------------------------------------------------------------
// Name: ReleaseAllObjects()
// ׂẴ_CNgh[ Object  Release B
//-----------------------------------------------------------------------------

void	ReleaseDD(void)
{
    if (g_pDD != NULL)
    {
		g_pDD->RestoreDisplayMode();
        if (g_pDDPal != NULL){
            g_pDDPal->Release();
            g_pDDPal = NULL;
        }
        if (g_pDDSOne != NULL)
        {
            g_pDDSOne->Release();
            g_pDDSOne = NULL;
        }
        if (g_pDDSPrimary != NULL)
        {
            g_pDDSPrimary->SetPalette(NULL);
			g_pDDSPrimary->Release();
            g_pDDSPrimary = NULL;
        }
        g_pDD->Release();
        g_pDD = NULL;
    }
}

#define TITLE               "Direct Draw Miss"
//-----------------------------------------------------------------------------
// Name: InitFail()
// sɌĂ΂֐
//-----------------------------------------------------------------------------
HRESULT	InitFail(HWND hWnd, HRESULT hRet, LPCTSTR szError,...)
{
    char                        szBuff[128];
    va_list                     vl;

    va_start(vl, szError);
    vsprintf(szBuff, szError, vl);
    ReleaseDD();
    MessageBox(hWnd, szBuff, TITLE, MB_OK);
    DestroyWindow(hWnd);
    va_end(vl);
    return hRet;
}


//-----------------------------------------------------------------------------
// Name: RestoreAll()
// Desc: Restore all lost objects
//-----------------------------------------------------------------------------
BOOL
RestoreAll(void)
{
	BOOL	bRet;
    bRet =  g_pDDSPrimary->Restore() == DD_OK &&
		g_pDDSOffScreen->Restore() == DD_OK &&
        DDReLoadBitmap(g_pDDSOne, szBitmap) == DD_OK;
	IgnoreTime();
	return	bRet;
}
void	IgnoreTime()
{
	LARGE_INTEGER	liTmp;
	::QueryPerformanceCounter( &liTmp);
	g_liCounter = liTmp;
	g_liRemainder = ConvertLongToLargeInteger(0);
}
HRESULT	
InitDD(HWND hWnd)
{
    DDSURFACEDESC2              ddsd;
    HRESULT                     hRet;
    LPDIRECTDRAW                pDD;

	g_Hwnd = hWnd;

	::InitTrifuncs();

	g_Hwnd = hWnd;
	g_rcScreen.top = 0;
	g_rcScreen.left = 0;
	g_rcScreen.bottom = 480;
	g_rcScreen.right = 640;
    hRet = DirectDrawCreate(NULL, &pDD, NULL);
    if (hRet != DD_OK)
        return InitFail(hWnd, hRet, "DirectDrawCreate FAILED");

    // Fetch DirectDraw4 interface
	hRet = pDD->QueryInterface(IID_IDirectDraw4, (LPVOID *) & g_pDD);
	if (hRet != DD_OK)
		return InitFail(hWnd, hRet, "QueryInterface FAILED");

	// Get normal mode
    hRet = pDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN);
    if (hRet != DD_OK)
        return InitFail(hWnd, hRet, "SetCooperativeLevel FAILED");

	hRet = pDD->SetDisplayMode(640,480,SCREEN_BIT_DEPTH);
	if (hRet != DD_OK)
		return	InitFail(hWnd, hRet, "SetDisplayMode FAILED");

    // Create the primary surface
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP|DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1;
    hRet = g_pDD->CreateSurface(&ddsd, &g_pDDSPrimary, NULL);
    if (hRet != DD_OK)
        return InitFail(hWnd, hRet, "CreateSurface FAILED");
//    ZeroMemory(&ddsd, sizeof(ddsd));
	DDSCAPS2 ddsc;
	ddsc.dwCaps = DDSCAPS_BACKBUFFER;
	hRet = g_pDDSPrimary->GetAttachedSurface(&ddsc,&g_pDDSOffScreen);
	if (hRet != DD_OK)
		return	InitFail(hWnd,hRet,"GetAttachedSurface FAILED");

//    ZeroMemory(&ddsd, sizeof(ddsd));

	if (SCREEN_BIT_DEPTH > 8){
		g_pDDPal=NULL;
	}else{
		g_pDDPal = DDLoadPalette(g_pDD, szBitmap);
		if (g_pDDPal)
			g_pDDSPrimary->SetPalette(g_pDDPal);
	}
	g_dwEraseColor = DDColorMatch(g_pDDSPrimary, 
									(120<<16)
									+(120<<8)
									+36);
	g_dwLineColor = DDColorMatch(g_pDDSPrimary, 
									(255<<16)
									+(255<<8)
									+255);

    // Load our bitmap
//	_RPT0(_CRT_WARN,"Load bitmap #1.\n");
//    g_pDDSOne = DDLoadBitmap(g_pDD, szBitmap, 0, 0);
//    if (g_pDDSOne == NULL)
//        return InitFail(hWnd, hRet, "DDLoadBitmap FAILED");
//	DDSetColorKeyFromPoint(g_pDDSOne, 0, 0);
//	_RPT0(_CRT_WARN,"Load bitmap #2.\n");

	::QueryPerformanceFrequency(&g_liFrequency);
	::QueryPerformanceCounter( &g_liCounter);
	g_liRemainder = ConvertLongToLargeInteger(0);
    return DD_OK;
}


/*
 *		DirectDraw ɂf̏
 */

void	UpdateDD(HWND hWnd)
{
    HRESULT                     hRet;

	LARGE_INTEGER	liTmp, liProgress;
	::QueryPerformanceCounter( &liTmp);
	liProgress = LargeIntegerSubtract(liTmp, g_liCounter);
	liProgress = EnlargedIntegerMultiply( liProgress.LowPart, FRAME_RATE*256);
	liProgress = LargeIntegerAdd( liProgress, g_liRemainder);
	liProgress = LargeIntegerDivide( liProgress, g_liFrequency, &g_liRemainder);
#if	0
	if (LargeIntegerEqualToZero(liProgress)){
		return;
	}
#endif
	g_liCounter = liTmp;
	DDBLTFX ddbltfx;
	ddbltfx.dwSize = sizeof(DDBLTFX);
	ddbltfx.dwFillColor = g_dwEraseColor;

	hRet = g_pDDSOffScreen->Blt(NULL, NULL, NULL, DDBLT_WAIT |
		DDBLT_COLORFILL, &ddbltfx);
 
	if (hRet == DDERR_SURFACELOST){
		if (!RestoreAll())
			return;
	}else{
		if (hRet != DD_OK)
			return;
	}
	DrawBox(g_pDDSOffScreen,liProgress.LowPart);

#ifdef	_DEBUG
	char	tmp[64];
		sprintf(tmp,"frames:%d\n",liProgress.LowPart);
		_RPT0(_CRT_WARN,tmp);
#endif
	hRet = g_pDDSPrimary->Flip(NULL,DDFLIP_WAIT);
    if (hRet == DDERR_SURFACELOST){
        RestoreAll();
    }
}
static	long	g_Angle = 0;
#define	CYCLE	4
#define	MAX_STEP	(60*CYCLE*2)
#define	DEFAULT_RADIUS	((double)64)

typedef struct{
	double	x;
	double	y;
}	fPOINT;
typedef struct{
	double	x;
	double	y;
	double	z;
}	Vertex;
typedef	struct{
	Vertex	v0;
	Vertex	v1;
}	LinePrimitive;
typedef	struct{
	fPOINT	v0;
	fPOINT	v1;
}	Line2D;
static	void	DrawLinePrimitive(LinePrimitive *line);
static	BOOL	ClipLine2D(Line2D *line2d);
static	void	DrawLine2D(IDirectDrawSurface4 * pdds,Line2D *line2d, DWORD color);
static	void	DrawLine2D_sub(DDSURFACEDESC2 *ddsd,Line2D *line2d,DWORD color);

static void	DrawBox(IDirectDrawSurface4 * pdds, long progress)
{
	long	pg;
	int		i,j;
	double	sinV,cosV;
	double	screenWidth;
	LinePrimitive	primitives[12];
	Vertex			point[8],tmp;

	pg = progress;
	pg *= SINE_STEP;
	pg /= FRAME_RATE * CYCLE * 256;
	g_Angle += pg;
	g_Angle %= SINE_STEP;
	screenWidth=(double)(g_rcScreen.right - g_rcScreen.left);

	point[4].x = point[0].x =  100.0 / screenWidth;
	point[4].z = point[0].z = -100.0 / screenWidth;
	point[5].x = point[1].x =  100.0 / screenWidth;
	point[5].z = point[1].z =  100.0 / screenWidth;
	point[6].x = point[2].x = -100.0 / screenWidth;
	point[6].z = point[2].z =  100.0 / screenWidth;
	point[7].x = point[3].x = -100.0 / screenWidth;
	point[7].z = point[3].z = -100.0 / screenWidth;
	point[0].y = point[1].y = point[2].y = point[3].y =-100.0 / screenWidth;
	point[4].y = point[5].y = point[6].y = point[7].y = 100.0 / screenWidth;

	//	Rotate it
	sinV = sin_fast(g_Angle);
	cosV = cos_fast(g_Angle);
#define	DISTANCE	((double)1.0)
	for (i = 0; i < 8; ++i){
		tmp.x = point[i].x * cosV - point[i].z * sinV;
		tmp.z = point[i].z * cosV + point[i].x * sinV;
		point[i].x = tmp.x;
		point[i].z = tmp.z + DISTANCE;
	}
	j = 0;
	for ( i = 0; i < 4; ++i){
		primitives[j].v0 = point[i];
		primitives[j++].v1 = point[(i+1)%4];
	}
	for ( i = 0; i < 4; ++i){
		primitives[j].v0 = point[i+4];
		primitives[j++].v1 = point[((i+1)%4)+4];
	}
	for (i = 0; i < 4; ++i){
		primitives[j].v0 = point[i];
		primitives[j++].v1 = point[i+4];
	}
	for ( i = 0; i < 12; ++i){
		DrawLinePrimitive(&primitives[i]);
	}
}

//
//		w肳ꂽ𓧎ϊĕ`悷B
//
static	void	DrawLinePrimitive(LinePrimitive *line)
{
	//	ϊ
	Line2D	line2d;
	double	ctr_x,ctr_y;
	double	tmpZ;
	double	screenWidth;
	ctr_x = (double)((g_rcScreen.left + g_rcScreen.right )/ 2);
	ctr_y = (double)((g_rcScreen.top + g_rcScreen.bottom) / 2);
	screenWidth=(double)(g_rcScreen.right - g_rcScreen.left);

#define	SCREEN_D	((double)0.1)
	if ((tmpZ = line->v0.z - SCREEN_D) < 0.001)	return;
	line2d.v0.x = line->v0.x / tmpZ;
	line2d.v0.y = -line->v0.y / tmpZ;
	if ((tmpZ = line->v1.z - SCREEN_D) < 0.001)	return;
	line2d.v1.x = line->v1.x / tmpZ;
	line2d.v1.y = -line->v1.y / tmpZ;
	line2d.v0.x *= screenWidth;
	line2d.v0.x += ctr_x;
	line2d.v0.y *= screenWidth;
	line2d.v0.y += ctr_y;
	line2d.v1.x *= screenWidth;
	line2d.v1.x += ctr_x;
	line2d.v1.y *= screenWidth;
	line2d.v1.y += ctr_y;
	if (ClipLine2D(&line2d)){
		DrawLine2D(g_pDDSOffScreen,&line2d,g_dwLineColor);
	}
}

//
//		w肳ꂽiQcjXN[Ɏ܂悤ɁA
//		NbsOB
//
static BOOL ClipLine2D(Line2D *line2d)
{
	double	tmp;
	fPOINT	w;
	if (line2d->v0.y > line2d->v1.y){;
		w = line2d->v0;
		line2d->v0 = line2d->v1;
		line2d->v1 = w;
	}
	if (line2d->v0.y > (double)g_rcScreen.bottom)
		return	FALSE;
	if (line2d->v1.y < (double)g_rcScreen.top)
		return	FALSE;
	if (line2d->v0.y < (double)g_rcScreen.top){
		if (line2d->v1.y != line2d->v0.y){
			tmp =(double)g_rcScreen.top - line2d->v0.y;
			tmp /= line2d->v1.y - line2d->v0.y;
			line2d->v0.x += tmp*(line2d->v1.x-line2d->v0.x);
		}
		line2d->v0.y = (double)g_rcScreen.top;
	}
	if (line2d->v1.y > (double)g_rcScreen.bottom){
		if (line2d->v0.y != line2d->v1.y){
			tmp = line2d->v1.y - (double)g_rcScreen.bottom;
			tmp /= line2d->v1.y - line2d->v0.y;
			line2d->v1.x -= tmp*(line2d->v1.x-line2d->v0.x);
		}
		line2d->v1.y = (double)g_rcScreen.bottom;
	}

	if (line2d->v0.x > line2d->v1.x){;
		w = line2d->v0;
		line2d->v0 = line2d->v1;
		line2d->v1 = w;
	}
	if (line2d->v0.x > (double)g_rcScreen.right)
		return	FALSE;
	if (line2d->v1.x < (double)g_rcScreen.left)
		return	FALSE;
	if (line2d->v0.x < (double)g_rcScreen.left){
		if (line2d->v0.x != line2d->v1.x){
			tmp = (double)g_rcScreen.left - line2d->v0.x;
			tmp /= line2d->v1.x - line2d->v0.x;
			line2d->v0.y += tmp * (line2d->v1.y-line2d->v0.y);
		}
		line2d->v0.x = g_rcScreen.left;
	}
	if (line2d->v1.x > (double)g_rcScreen.right){
		if (line2d->v0.x != line2d->v1.x){
			tmp = line2d->v1.x - (double)g_rcScreen.right;
			tmp /= line2d->v1.x - line2d->v0.x;
			line2d->v1.y -= tmp * (line2d->v1.y - line2d->v0.y);
		}
		line2d->v0.x = g_rcScreen.right;
	}
	return	TRUE;
}

//
//	w肳ꂽ̕`îPj
//
static	void	DrawLine2D(IDirectDrawSurface4 * pdds,Line2D *line2d, DWORD color)
{
    DDSURFACEDESC2          ddsdScreen;
    HRESULT                 hres;
	//if (CheckBack(p3))	return;
	ddsdScreen.dwSize = sizeof(ddsdScreen);
    while ((hres = g_pDDSOffScreen->Lock(NULL, &ddsdScreen, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	if (hres!=DD_OK){
		return;
	}	
	if ((ddsdScreen.ddpfPixelFormat.dwRGBBitCount >> 3)
		!= ((SCREEN_BIT_DEPTH+7)>>3)
	){
		g_pDDSOffScreen->Unlock(NULL);
		return;
	}
	DrawLine2D_sub(&ddsdScreen,line2d,color);
	g_pDDSOffScreen->Unlock(NULL);
}

//
//		w肳ꂽ̕`îQj
//
#if	SCREEN_BIT_DEPTH==8
#define	setpixel(p,c)	(*(BYTE*)p = (BYTE)c)
#else
#define	setpixel(p,c)	(*(unsigned short*)p = (unsigned short)c)
#endif
static	void	DrawLine2D_sub(DDSURFACEDESC2 *ddsd,Line2D *line2d,DWORD color)
{
	int	x0,y0,x1,y1,tmp;
	int	width,height;
	BYTE	*screenBase,*ptr;
	long	pixelsize=ddsd->ddpfPixelFormat.dwRGBBitCount >> 3;
	long	linesize=ddsd->lPitch;

	screenBase = (BYTE*)ddsd->lpSurface;
	x0 = (int)line2d->v0.x;	y0 = (int)line2d->v0.y;
	x1 = (int)line2d->v1.x;	y1 = (int)line2d->v1.y;
	width = abs(x1-x0);
	height = abs(y1-y0);
	if (width>height){
		if (x1 < x0){
			tmp = x0;	x0 = x1;	x1 = tmp;
			tmp = y0;	y0 = y1;	y1 = tmp;
		}
		height = y1-y0;
		screenBase += linesize  * y0;
		screenBase += pixelsize * x0;
		x1 -= x0;
		y1 -= y0;
		if (height==0){
			ptr = screenBase;
			for(x0 = 0;x0 < x1; ++x0){
				setpixel(ptr,color);
				ptr+=pixelsize;
			}
		}else{
			for(x0=0,y0=0;x0<=x1;++x0){
				tmp = (y1*x0)/width;
				ptr = screenBase+(linesize*tmp);
				ptr+= pixelsize*x0;
				setpixel(ptr,color);
			}
		}
	}else{
		if (y1 < y0){
			tmp = x0;	x0 = x1;	x1 = tmp;
			tmp = y0;	y0 = y1;	y1 = tmp;
		}
		width = x1-x0;
		screenBase += linesize  * y0;
		screenBase += pixelsize * x0;
		x1 -= x0;
		y1 -= y0;
		if (width==0){
			ptr = screenBase;
			for(y0 = 0; y0 <= y1 ; ++y0){
				setpixel(ptr,color);
				ptr += linesize;
			}
		}else{
			for(x0 = 0, y0 = 0 ; y0 <= y1 ; ++y0){
				tmp = (x1*y0)/height;
				ptr = screenBase+(pixelsize*tmp);
				ptr+= linesize*y0;
				setpixel(ptr,color);
			}
		}
	}
}
/*
 *
 *		ȉׂāArcjt̃Tv
 *		ʂ
 *
 */

static DWORD
DDColorPick(IDirectDrawSurface4 * pdds, int x, int y)
{
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;
	BYTE	*ptr;
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
		ptr = (BYTE*)ddsd.lpSurface;
		ptr += ddsd.lPitch * y;
		ptr += (ddsd.ddpfPixelFormat.dwRGBBitCount / 8) * x;
        dw = *(DWORD *)ptr;		// Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        pdds->Unlock(NULL);
    }
    return dw;
}


extern "C" HRESULT
DDSetColorKeyFromPoint(IDirectDrawSurface4 * pdds, int x, int y)
{
	DDCOLORKEY	ddck;
    ddck.dwColorSpaceLowValue = DDColorPick(pdds, x, y);
    ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
    return pdds->SetColorKey(DDCKEY_SRCBLT, &ddck);
}

//-----------------------------------------------------------------------------
// Name: DDLoadBitmap()
// Desc: Create a DirectDrawSurface from a bitmap resource.
//-----------------------------------------------------------------------------
extern "C" IDirectDrawSurface4 *
DDLoadBitmap(IDirectDraw4 * pdd, LPCSTR szBitmap, int dx, int dy)
{
    HBITMAP                 hbm;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    IDirectDrawSurface4    *pdds;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, dx,
                              dy, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, dx, dy,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
        return NULL;
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    //
    // Create a DirectDrawSurface for this bitmap
    //
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = bm.bmWidth;
    ddsd.dwHeight = bm.bmHeight;
    if (pdd->CreateSurface(&ddsd, &pdds, NULL) != DD_OK)
        return NULL;
    DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
    DeleteObject(hbm);
    return pdds;
}

//-----------------------------------------------------------------------------
// Name: DDReLoadBitmap()
// Desc: Load a bitmap from a file or resource into a directdraw surface.
//       normaly used to re-load a surface after a restore.
//-----------------------------------------------------------------------------
HRESULT
DDReLoadBitmap(IDirectDrawSurface4 * pdds, LPCSTR szBitmap)
{
    HBITMAP                 hbm;
    HRESULT                 hr;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, 0,
                              0, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, 0, 0,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
    {
        return E_FAIL;
    }
    hr = DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
//  if (hr != DD_OK)
//	{
//		TRACE("ddcopybitmap failed\n");
//	}
    DeleteObject(hbm);
    return hr;
}

//-----------------------------------------------------------------------------
// Name: DDCopyBitmap()
// Desc: Draw a bitmap into a DirectDrawSurface
//-----------------------------------------------------------------------------
extern "C" HRESULT
DDCopyBitmap(IDirectDrawSurface4 * pdds, HBITMAP hbm, int x, int y,
             int dx, int dy)
{
    HDC                     hdcImage;
    HDC                     hdc;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hr;

    if (hbm == NULL || pdds == NULL)
        return E_FAIL;
    //
    // Make sure this surface is restored.
    //
    pdds->Restore();
    //
    // Select bitmap into a memoryDC so we can use it.
    //
    hdcImage = CreateCompatibleDC(NULL);
//    if (!hdcImage)
//        TRACE("createcompatible dc failed\n");
    SelectObject(hdcImage, hbm);
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    dx = dx == 0 ? bm.bmWidth : dx;     // Use the passed size, unless zero
    dy = dy == 0 ? bm.bmHeight : dy;
    //
    // Get size of surface.
    //
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH;
    pdds->GetSurfaceDesc(&ddsd);

    if ((hr = pdds->GetDC(&hdc)) == DD_OK)
    {
        StretchBlt(hdc, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hdcImage, x, y,
                   dx, dy, SRCCOPY);
        pdds->ReleaseDC(hdc);
    }
    DeleteDC(hdcImage);
    return hr;
}

//-----------------------------------------------------------------------------
// Name: DDLoadPalette()
// Desc: Create a DirectDraw palette object from a bitmap resource
//       if the resource does not exist or NULL is passed create a
//       default 332 palette.
//-----------------------------------------------------------------------------
extern "C" IDirectDrawPalette *
DDLoadPalette(IDirectDraw4 * pdd, LPCSTR szBitmap)
{
    IDirectDrawPalette     *ddpal;
    int                     i;
    int                     n;
    int                     fh;
    HRSRC                   h;
    LPBITMAPINFOHEADER      lpbi;
    PALETTEENTRY            ape[256];
    RGBQUAD                *prgb;

    //
    // Build a 332 palette as the default.
    //
    for (i = 0; i < 256; i++)
    {
        ape[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        ape[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        ape[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        ape[i].peFlags = (BYTE) 0;
    }
    //
    // Get a pointer to the bitmap resource.
    //
    if (szBitmap && (h = FindResource(NULL, szBitmap, RT_BITMAP)))
    {
        lpbi = (LPBITMAPINFOHEADER) LockResource(LoadResource(NULL, h));
//        if (!lpbi)
//            TRACE("lock resource failed\n");
        prgb = (RGBQUAD *) ((BYTE *) lpbi + lpbi->biSize);
        if (lpbi == NULL || lpbi->biSize < sizeof(BITMAPINFOHEADER))
            n = 0;
        else if (lpbi->biBitCount > 8)
            n = 0;
        else if (lpbi->biClrUsed == 0)
            n = 1 << lpbi->biBitCount;
        else
            n = lpbi->biClrUsed;
        //
        //  A DIB color table has its colors stored BGR not RGB
        //  so flip them around.
        //
        for (i = 0; i < n; i++)
        {
            ape[i].peRed = prgb[i].rgbRed;
            ape[i].peGreen = prgb[i].rgbGreen;
            ape[i].peBlue = prgb[i].rgbBlue;
            ape[i].peFlags = 0;
        }
    }
    else if (szBitmap && (fh = _lopen(szBitmap, OF_READ)) != -1)
    {
        BITMAPFILEHEADER        bf;
        BITMAPINFOHEADER        bi;

        _lread(fh, &bf, sizeof(bf));
        _lread(fh, &bi, sizeof(bi));
        _lread(fh, ape, sizeof(ape));
        _lclose(fh);
        if (bi.biSize != sizeof(BITMAPINFOHEADER))
            n = 0;
        else if (bi.biBitCount > 8)
            n = 0;
        else if (bi.biClrUsed == 0)
            n = 1 << bi.biBitCount;
        else
            n = bi.biClrUsed;
        //
        //  A DIB color table has its colors stored BGR not RGB
        //  so flip them around.
        //
        for (i = 0; i < n; i++)
        {
            BYTE        r = ape[i].peRed;

            ape[i].peRed = ape[i].peBlue;
            ape[i].peBlue = r;
        }
    }
    pdd->CreatePalette(DDPCAPS_8BIT, ape, &ddpal, NULL);
    return ddpal;
}




//-----------------------------------------------------------------------------
// Name: DDColorMatch()
// Desc: Convert a RGB color to a pysical color.
//       We do this by leting GDI SetPixel() do the color matching
//       then we lock the memory and see what it got mapped to.
//-----------------------------------------------------------------------------
extern "C" DWORD
DDColorMatch(IDirectDrawSurface4 * pdds, COLORREF rgb)
{
    COLORREF                rgbT;
    HDC                     hdc;
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;

    //
    //  Use GDI SetPixel to color match for us
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, rgb);       // Set our value
        pdds->ReleaseDC(hdc);
    }
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface;                 // Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        pdds->Unlock(NULL);
    }
    //
    //  Now put the color that was there back.
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        pdds->ReleaseDC(hdc);
    }
    return dw;
}



//-----------------------------------------------------------------------------
// Name: DDSetColorKey()
// Desc: Set a color key for a surface, given a RGB.
//       If you pass CLR_INVALID as the color key, the pixel
//       in the upper-left corner will be used.
//-----------------------------------------------------------------------------
extern "C" HRESULT
DDSetColorKey(IDirectDrawSurface4 * pdds, COLORREF rgb)
{
    DDCOLORKEY              ddck;

    ddck.dwColorSpaceLowValue = DDColorMatch(pdds, rgb);
    ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
    return pdds->SetColorKey(DDCKEY_SRCBLT, &ddck);
}

