/*
 *
 *		\tgEFAɂAeLX`tOp|S\
 *		iᑬj
 *		First edition:	Nov.03.2001
 *		Author:			Yohei Kishimoto
 *						based on Microsoft's DirectX sample program.
 */

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <crtdbg.h>

#include "resource.h"
#include <largeint.h>
#include <math.h>
#include <time.h>
#include <ddraw.h>
#include "GameMain.h"
#include "Trifunc.h"

//-----------------------------------------------------------------------------
// Global data
//-----------------------------------------------------------------------------
LPDIRECTDRAW4               g_pDD = NULL;        // DirectDraw object
LPDIRECTDRAWSURFACE4        g_pDDSPrimary = NULL;// DirectDraw primary surface
LPDIRECTDRAWSURFACE4		g_pDDSOffScreen = NULL;
LPDIRECTDRAWCLIPPER         g_pClipper = NULL;   // Clipper for primary
LPDIRECTDRAWPALETTE         g_pDDPal = NULL;     // The primary surface palette
LPDIRECTDRAWSURFACE4		g_pDDSOne = NULL;
static char                *szBitmap = MAKEINTRESOURCE(IDB_BITMAP1);
HWND			g_Hwnd;
LARGE_INTEGER	g_liFrequency;
LARGE_INTEGER	g_liCounter;
LARGE_INTEGER	g_liRemainder;
RECT			g_rcScreen;
DWORD			g_dwEraseColor;
DWORD			g_dwLineColor;

#define	SCREEN_SCALE	((double)(g_rcScreen.right - g_rcScreen.left)/2.0)

static void	DrawBox(IDirectDrawSurface4 * pdds, long progress);
void	IgnoreTime();

#define	SCREEN_BIT_DEPTH	8
#define	FRAME_RATE	60
void	DestroyThisApp()
{
}

//-----------------------------------------------------------------------------
// Name: ReleaseAllObjects()
// ׂẴ_CNgh[ Object  Release B
//-----------------------------------------------------------------------------

void	ReleaseDD(void)
{
    if (g_pDD != NULL)
    {
		g_pDD->RestoreDisplayMode();
		if (g_pDDPal != NULL){
			g_pDDPal->Release();
			g_pDDPal = NULL;
		}
        if (g_pDDSOne != NULL)
        {
            g_pDDSOne->Release();
            g_pDDSOne = NULL;
        }
        if (g_pDDSPrimary != NULL)
        {
            g_pDDSPrimary->SetPalette(NULL);
			g_pDDSPrimary->Release();
            g_pDDSPrimary = NULL;
        }
        g_pDD->Release();
        g_pDD = NULL;
    }
}

#define TITLE               "Direct Draw Miss"
//-----------------------------------------------------------------------------
// Name: InitFail()
// sɌĂ΂֐
//-----------------------------------------------------------------------------
HRESULT	InitFail(HWND hWnd, HRESULT hRet, LPCTSTR szError,...)
{
    char                        szBuff[128];
    va_list                     vl;

    va_start(vl, szError);
    vsprintf(szBuff, szError, vl);
    ReleaseDD();
    MessageBox(hWnd, szBuff, TITLE, MB_OK);
    DestroyWindow(hWnd);
    va_end(vl);
    return hRet;
}


//-----------------------------------------------------------------------------
// Name: RestoreAll()
// Desc: Restore all lost objects
//-----------------------------------------------------------------------------
BOOL
RestoreAll(void)
{
	BOOL	bRet;
    bRet =  g_pDDSPrimary->Restore() == DD_OK &&
		g_pDDSOffScreen->Restore() == DD_OK &&
        DDReLoadBitmap(g_pDDSOne, szBitmap) == DD_OK;
	IgnoreTime();
	return	bRet;
}
void	IgnoreTime()
{
	LARGE_INTEGER	liTmp;
	::QueryPerformanceCounter( &liTmp);
	g_liCounter = liTmp;
	g_liRemainder = ConvertLongToLargeInteger(0);
}
HRESULT	
InitDD(HWND hWnd)
{
    DDSURFACEDESC2              ddsd;
    HRESULT                     hRet;
    LPDIRECTDRAW                pDD;

	g_Hwnd = hWnd;

	::InitTrifuncs();

	g_Hwnd = hWnd;
	g_rcScreen.top = 0;
	g_rcScreen.left = 0;
	g_rcScreen.bottom = 480;
	g_rcScreen.right = 640;
    hRet = DirectDrawCreate(NULL, &pDD, NULL);
    if (hRet != DD_OK)
        return InitFail(hWnd, hRet, "DirectDrawCreate FAILED");

    // Fetch DirectDraw4 interface
	hRet = pDD->QueryInterface(IID_IDirectDraw4, (LPVOID *) & g_pDD);
	if (hRet != DD_OK)
		return InitFail(hWnd, hRet, "QueryInterface FAILED");

	// Get normal mode
    hRet = pDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN);
    if (hRet != DD_OK)
        return InitFail(hWnd, hRet, "SetCooperativeLevel FAILED");

	hRet = pDD->SetDisplayMode(640,480,SCREEN_BIT_DEPTH);
	if (hRet != DD_OK)
		return	InitFail(hWnd, hRet, "SetDisplayMode FAILED");

    // Create the primary surface
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP|DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1;
    hRet = g_pDD->CreateSurface(&ddsd, &g_pDDSPrimary, NULL);
    if (hRet != DD_OK)
        return InitFail(hWnd, hRet, "CreateSurface FAILED");
	DDSCAPS2 ddsc;
	ddsc.dwCaps = DDSCAPS_BACKBUFFER;
	hRet = g_pDDSPrimary->GetAttachedSurface(&ddsc,&g_pDDSOffScreen);
	if (hRet != DD_OK)
		return	InitFail(hWnd,hRet,"GetAttachedSurface FAILED");

	if (SCREEN_BIT_DEPTH > 8){
		g_pDDPal=NULL;
	}else{
		g_pDDPal = DDLoadPalette(g_pDD, szBitmap);
		if (g_pDDPal)
			g_pDDSPrimary->SetPalette(g_pDDPal);
	}

	g_dwEraseColor = DDColorMatch(g_pDDSPrimary,
									(120<<16)
									+(120<<8)
									+36);
	g_dwLineColor = DDColorMatch(g_pDDSPrimary, 
									(255<<16)
									+(255<<8)
									+255);

    // Load our bitmap
    g_pDDSOne = DDLoadBitmap(g_pDD, szBitmap, 0, 0);
    if (g_pDDSOne == NULL)
        return InitFail(hWnd, hRet, "DDLoadBitmap FAILED");
//	DDSetColorKeyFromPoint(g_pDDSOne, 0, 0);

	::QueryPerformanceFrequency(&g_liFrequency);
	::QueryPerformanceCounter( &g_liCounter);
	g_liRemainder = ConvertLongToLargeInteger(0);

    return DD_OK;
}


/*
 *		DirectDraw ɂf̏
 */

void	UpdateDD(HWND hWnd)
{
    HRESULT                     hRet;

	LARGE_INTEGER	liTmp, liProgress;
	::QueryPerformanceCounter( &liTmp);
	liProgress = LargeIntegerSubtract(liTmp, g_liCounter);
	liProgress = EnlargedIntegerMultiply( liProgress.LowPart, FRAME_RATE*256);
	liProgress = LargeIntegerAdd( liProgress, g_liRemainder);
	liProgress = LargeIntegerDivide( liProgress, g_liFrequency, &g_liRemainder);

	g_liCounter = liTmp;
	DDBLTFX ddbltfx;
	ddbltfx.dwSize = sizeof(DDBLTFX);
	ddbltfx.dwFillColor = g_dwEraseColor;

	hRet = g_pDDSOffScreen->Blt(NULL, NULL, NULL, DDBLT_WAIT |
		DDBLT_COLORFILL, &ddbltfx);
 
	if (hRet == DDERR_SURFACELOST){
		if (!RestoreAll())
			return;
	}else{
		if (hRet != DD_OK)
			return;
	}
	DrawBox(g_pDDSOffScreen,liProgress.LowPart);

#ifdef	_DEBUG
	char	tmp[64];
	sprintf(tmp,"frames:%d\n",liProgress.LowPart);
	_RPT0(_CRT_WARN,tmp);
#endif
	hRet = g_pDDSPrimary->Flip(NULL,DDFLIP_WAIT);
    if (hRet == DDERR_SURFACELOST){
        RestoreAll();
    }
}
static	long	g_Angle = 0;
static	long	g_Angle1 = 0;
static	long	g_Angle2 = 0;
static	long	g_Angle3 = 0;
#define	CYCLE1	4
#define	CYCLE2	7
#define	CYCLE3	3
#define	SCREEN_DISTANCE	((double)0)
typedef struct{
	double	x;
	double	y;
}	fPOINT;
typedef struct{
	double	x;
	double	y;
	double	z;
}	fVertex;

typedef struct{
	fVertex	v0;
	fPOINT	tv0;
	fVertex	v1;
	fPOINT	tv1;
	fVertex	v2;
	fPOINT	tv2;
}	Tex3NoShade3D;

typedef struct{
	fPOINT	v0;
	fPOINT	v1;
	fPOINT	v2;
}	Poly3;

static BOOL	GetPoly3Boundary(RECT *bound, Poly3 *p3);
static void	FillPoly3(Tex3NoShade3D *p3);
static void	FillPoly3_sub(DDSURFACEDESC2 *ddsdScreen,DDSURFACEDESC2 *ddsdTex,Tex3NoShade3D *p3, Poly3 *p2_3d);
static	void	FillPoly3_sub2D(DDSURFACEDESC2 *ddsdScreen,DDSURFACEDESC2 *ddsdTex,Tex3NoShade3D *p3,Poly3 *p3_2d);
static BOOL CheckBack(Poly3 *p3);
static inline void	GetPoly3LeftRight(Poly3 *p3,RECT *bound,double line, double &dsx,double &dex);
static inline	void GetPoly3TexPos(Tex3NoShade3D *p3,double &tx,double &ty,double u,double v);

typedef struct{
	fVertex	v0;
	fPOINT	tv0;
	fVertex	v1;
	fPOINT	tv1;
	fVertex	v2;
	fPOINT	tv2;
	fVertex	v3;
	fPOINT	tv3;
}	Tex4NoShade3D;
typedef struct{
	Tex4NoShade3D	tex4;
	double			zValue;
}	Tex4Prim;
double	g_dbScreenScale;
double	g_dbScreenCenterX;
double	g_dbScreenCenterY;
static	void	FillPoly4(Tex4NoShade3D *p4);
static	void	BuildDice1(fVertex	*point);
static	int		BuildDice2(fVertex *point, Tex4Prim *polygons);
static	void	SortPolygons(Tex4Prim *polygons, Tex4Prim *primitives[], int n);

static void	BuildDice1(fVertex	*point)
{
	point[4].x = point[0].x = -100.0 / g_dbScreenScale;
	point[4].z = point[0].z =  100.0 / g_dbScreenScale;
	point[5].x = point[1].x = -100.0 / g_dbScreenScale;
	point[5].z = point[1].z = -100.0 / g_dbScreenScale;
	point[6].x = point[2].x =  100.0 / g_dbScreenScale;
	point[6].z = point[2].z = -100.0 / g_dbScreenScale;
	point[7].x = point[3].x =  100.0 / g_dbScreenScale;
	point[7].z = point[3].z =  100.0 / g_dbScreenScale;
	point[0].y = point[1].y = point[2].y = point[3].y =-100.0 / g_dbScreenScale;
	point[4].y = point[5].y = point[6].y = point[7].y = 100.0 / g_dbScreenScale;
}

static void	EnhalfTex4(Tex4NoShade3D *tex);
static void	EnhalfTex4(Tex4NoShade3D *tex)
{
	double	tmp;
	tmp = tex->v0.x+tex->v1.x+tex->v2.x+tex->v3.x;
	tex->v0.x = (tex->v0.x-tmp)/2.0+tmp;
	tex->v1.x = (tex->v1.x-tmp)/2.0+tmp;
	tex->v2.x = (tex->v2.x-tmp)/2.0+tmp;
	tex->v3.x = (tex->v3.x-tmp)/2.0+tmp;

	tmp = tex->v0.y+tex->v1.y+tex->v2.y+tex->v3.y;
	tex->v0.y = (tex->v0.y-tmp)/2.0+tmp;
	tex->v1.y = (tex->v1.y-tmp)/2.0+tmp;
	tex->v2.y = (tex->v2.y-tmp)/2.0+tmp;
	tex->v3.y = (tex->v3.y-tmp)/2.0+tmp;

	tmp = tex->v0.z+tex->v1.z+tex->v2.z+tex->v3.z;
	tex->v0.z = (tex->v0.z-tmp)/2.0+tmp;
	tex->v1.z = (tex->v1.z-tmp)/2.0+tmp;
	tex->v2.z = (tex->v2.z-tmp)/2.0+tmp;
	tex->v3.z = (tex->v3.z-tmp)/2.0+tmp;
}
static	int	BuildDice2(fVertex *point, Tex4Prim *polygons)
{	
	int	j = 0;
#if	1
	/*	1	*/
	polygons[j].tex4.v0.x = point[3].x;
	polygons[j].tex4.v0.y = point[3].y;
	polygons[j].tex4.v0.z = point[3].z;
	polygons[j].tex4.v1.x = point[2].x;
	polygons[j].tex4.v1.y = point[2].y;
	polygons[j].tex4.v1.z = point[2].z;
	polygons[j].tex4.v2.x = point[1].x;
	polygons[j].tex4.v2.y = point[1].y;
	polygons[j].tex4.v2.z = point[1].z;
	polygons[j].tex4.v3.x = point[0].x;
	polygons[j].tex4.v3.y = point[0].y;
	polygons[j].tex4.v3.z = point[0].z;
	polygons[j].tex4.tv0.x =  0;
	polygons[j].tex4.tv0.y =  0;
	polygons[j].tex4.tv1.x = 99;
	polygons[j].tex4.tv1.y =  0;
	polygons[j].tex4.tv2.x = 99;
	polygons[j].tex4.tv2.y = 99;
	polygons[j].tex4.tv3.x = 99;
	polygons[j++].tex4.tv3.y =0;
	/*	6	*/
	polygons[j].tex4.v0.x = point[4].x;
	polygons[j].tex4.v0.y = point[4].y;
	polygons[j].tex4.v0.z = point[4].z;
	polygons[j].tex4.v1.x = point[5].x;
	polygons[j].tex4.v1.y = point[5].y;
	polygons[j].tex4.v1.z = point[5].z;
	polygons[j].tex4.v2.x = point[6].x;
	polygons[j].tex4.v2.y = point[6].y;
	polygons[j].tex4.v2.z = point[6].z;
	polygons[j].tex4.v3.x = point[7].x;
	polygons[j].tex4.v3.y = point[7].y;
	polygons[j].tex4.v3.z = point[7].z;
	polygons[j].tex4.tv0.x = 200;
	polygons[j].tex4.tv0.y = 100;
	polygons[j].tex4.tv1.x = 299;
	polygons[j].tex4.tv1.y = 100;
	polygons[j].tex4.tv2.x = 299;
	polygons[j].tex4.tv2.y = 199;
	polygons[j].tex4.tv3.x = 200;
	polygons[j++].tex4.tv3.y = 199;
#endif
#if	1
	/*	2	*/
	polygons[j].tex4.v0.x = point[0].x;
	polygons[j].tex4.v0.y = point[0].y;
	polygons[j].tex4.v0.z = point[0].z;
	polygons[j].tex4.v1.x = point[1].x;
	polygons[j].tex4.v1.y = point[1].y;
	polygons[j].tex4.v1.z = point[1].z;
	polygons[j].tex4.v2.x = point[5].x;
	polygons[j].tex4.v2.y = point[5].y;
	polygons[j].tex4.v2.z = point[5].z;
	polygons[j].tex4.v3.x = point[4].x;
	polygons[j].tex4.v3.y = point[4].y;
	polygons[j].tex4.v3.z = point[4].z;
	polygons[j].tex4.tv0.x = 100;
	polygons[j].tex4.tv0.y =   0;
	polygons[j].tex4.tv1.x = 199;
	polygons[j].tex4.tv1.y =   0;
	polygons[j].tex4.tv2.x = 199;
	polygons[j].tex4.tv2.y =  99;
	polygons[j].tex4.tv3.x = 100;
	polygons[j++].tex4.tv3.y =99;
#endif
	/*	5	*/
	polygons[j].tex4.v0.x = point[2].x;
	polygons[j].tex4.v0.y = point[2].y;
	polygons[j].tex4.v0.z = point[2].z;
	polygons[j].tex4.v1.x = point[3].x;
	polygons[j].tex4.v1.y = point[3].y;
	polygons[j].tex4.v1.z = point[3].z;
	polygons[j].tex4.v2.x = point[7].x;
	polygons[j].tex4.v2.y = point[7].y;
	polygons[j].tex4.v2.z = point[7].z;
	polygons[j].tex4.v3.x = point[6].x;
	polygons[j].tex4.v3.y = point[6].y;
	polygons[j].tex4.v3.z = point[6].z;
	polygons[j].tex4.tv0.x = 100;
	polygons[j].tex4.tv0.y = 199;
	polygons[j].tex4.tv1.x = 199;
	polygons[j].tex4.tv1.y = 199;
	polygons[j].tex4.tv2.x = 199;
	polygons[j].tex4.tv2.y = 100;
	polygons[j].tex4.tv3.x = 100;
	polygons[j++].tex4.tv3.y = 100;
#if	1
	/*	3	*/
	polygons[j].tex4.v0.x = point[1].x;
	polygons[j].tex4.v0.y = point[1].y;
	polygons[j].tex4.v0.z = point[1].z;
	polygons[j].tex4.v1.x = point[2].x;
	polygons[j].tex4.v1.y = point[2].y;
	polygons[j].tex4.v1.z = point[2].z;
	polygons[j].tex4.v2.x = point[6].x;
	polygons[j].tex4.v2.y = point[6].y;
	polygons[j].tex4.v2.z = point[6].z;
	polygons[j].tex4.v3.x = point[5].x;
	polygons[j].tex4.v3.y = point[5].y;
	polygons[j].tex4.v3.z = point[5].z;
	polygons[j].tex4.tv0.x = 200;
	polygons[j].tex4.tv0.y = 99;
	polygons[j].tex4.tv1.x = 299;
	polygons[j].tex4.tv1.y = 99;
	polygons[j].tex4.tv2.x = 299;
	polygons[j].tex4.tv2.y = 0;
	polygons[j].tex4.tv3.x = 200;
	polygons[j++].tex4.tv3.y = 0;

	/*	4	*/
	polygons[j].tex4.v0.x = point[3].x;
	polygons[j].tex4.v0.y = point[3].y;
	polygons[j].tex4.v0.z = point[3].z;
	polygons[j].tex4.v1.x = point[0].x;
	polygons[j].tex4.v1.y = point[0].y;
	polygons[j].tex4.v1.z = point[0].z;
	polygons[j].tex4.v2.x = point[4].x;
	polygons[j].tex4.v2.y = point[4].y;
	polygons[j].tex4.v2.z = point[4].z;
	polygons[j].tex4.v3.x = point[7].x;
	polygons[j].tex4.v3.y = point[7].y;
	polygons[j].tex4.v3.z = point[7].z;
	polygons[j].tex4.tv0.x =   0;
	polygons[j].tex4.tv0.y = 100;
	polygons[j].tex4.tv1.x =  99;
	polygons[j].tex4.tv1.y = 100;
	polygons[j].tex4.tv2.x =  99;
	polygons[j].tex4.tv2.y = 199;
	polygons[j].tex4.tv3.x =   0;
	polygons[j++].tex4.tv3.y = 199;
#endif
	return	j;
}

static void	SortPolygons(Tex4Prim *polygons, Tex4Prim *primitives[], int n)
{
	int	i,j;
	double	tmp;
	Tex4Prim	*swp;
	for(i = 0; i < n;++i){
		tmp = polygons[i].tex4.v0.z;
		tmp += polygons[i].tex4.v1.z;
		tmp += polygons[i].tex4.v2.z;
		tmp += polygons[i].tex4.v3.z;
		tmp /= 4.0;
		polygons[i].zValue=tmp;
		primitives[i]=&polygons[i];
	}
	for(i=1;i<n;++i){
		for(j=i;j>0;--j){
			if (primitives[j]->zValue>primitives[j-1]->zValue){
				swp = primitives[j];
				primitives[j]=primitives[j-1];
				primitives[j-1]=swp;
			}else
				break;
		}
	}
}
static void	DrawBox(IDirectDrawSurface4 * pdds, long progress)
{
	long	pg;
	int		i,j;
	double	sinV1,cosV1,sinV2,cosV2,sinV3,cosV3;
	long	tmp_a;

	Tex4Prim		polygons[6],*primitives[6];
	fVertex			point[8],tmp;

	g_dbScreenScale = SCREEN_SCALE;
	g_dbScreenCenterX = (double)((g_rcScreen.left + g_rcScreen.right )/ 2);
	g_dbScreenCenterY = (double)((g_rcScreen.top + g_rcScreen.bottom) / 2);

	BuildDice1(point);
	pg = progress;
	pg *= SINE_STEP * 256;
	pg /= FRAME_RATE * CYCLE1* 256;
	g_Angle1 -= pg;
	g_Angle1 %= SINE_STEP*256;
	pg = progress;
	pg *= SINE_STEP * 256;
	pg /= FRAME_RATE * CYCLE2 * 256;
	g_Angle2 += pg;
	g_Angle2 %= SINE_STEP*256;
	pg = progress;
	pg *= SINE_STEP*256;
	pg /= FRAME_RATE * CYCLE3 * 256;
	g_Angle3 += pg;
	g_Angle3 %= SINE_STEP*256;

	//	Rotate it
	tmp_a = g_Angle1>>8;
	sinV1 = sin_fast(tmp_a);
	cosV1 = cos_fast(tmp_a);
	tmp_a = g_Angle2>>8;
	sinV2 = sin_fast(tmp_a);
	cosV2 = cos_fast(tmp_a);
	tmp_a = g_Angle3>>8;
	sinV3 = sin_fast(tmp_a);
	cosV3 = cos_fast(tmp_a);
#define	DISTANCE2	((double)2.1)
	for (i = 0; i < 8; ++i){
		//	w]
		tmp.x = point[i].x;
		tmp.y = point[i].y * cosV2 - point[i].z * sinV2;
		tmp.z = point[i].z * cosV2 + point[i].y * sinV2;
		point[i] = tmp;
		//	x]
		tmp.x = point[i].x * cosV1 - point[i].z * sinV1;
		tmp.z = point[i].z * cosV1 + point[i].x * sinV1;
		point[i] = tmp;
		//	y]
		//tmp.y = point[i].y * cosV3 + point[i].x * sinV3;
		//tmp.x = point[i].x * cosV3 - point[i].y * sinV3;
		tmp.z += DISTANCE2;
		point[i] = tmp;
	}
	j=BuildDice2(point,polygons);
	SortPolygons(polygons,primitives,j);
	for (i = 0; i < j;++i)
		FillPoly4(&primitives[i]->tex4);
}

static	void	FillPoly4(Tex4NoShade3D *p4)
{
	Tex3NoShade3D	p3;
	p3.v0  = p4->v1;
	p3.tv0 = p4->tv1;
	p3.v1  = p4->v2;
	p3.tv1 = p4->tv2;
	p3.v2  = p4->v0;
	p3.tv2 = p4->tv0;
	FillPoly3(&p3);
	p3.v0  = p4->v3;
	p3.tv0 = p4->tv3;
	p3.v1  = p4->v0;
	p3.tv1 = p4->tv0;
	p3.v2  = p4->v2;
	p3.tv2 = p4->tv2;
	FillPoly3(&p3);
}

static inline BOOL CheckBack(Poly3 *p3)
{
	//	Oς߁A\𔻒B
	return(
		0 < 
		(p3->v1.x - p3->v0.x)*(p3->v2.y - p3->v0.y)
		-(p3->v1.y - p3->v0.y)*(p3->v2.x - p3->v0.x)
	);

}

/*
 *		Op|S͂ރN^OZoB
 *		`spiʊOjȂAFALSE ԂB
 */
static inline BOOL	GetPoly3Boundary(RECT *bound, Poly3 *p3)
{
	double	tmp;
	double	top,bottom;
	//	Get boundary.
	tmp = p3->v0.x;
	if (p3->v1.x < tmp)	tmp = p3->v1.x;
	if (p3->v2.x < tmp)	tmp = p3->v2.x;
	if (tmp > (double)g_rcScreen.right)
		return	FALSE;
	if (tmp < (double)g_rcScreen.left)
		bound->left = g_rcScreen.left;
	else
		bound->left = (long)tmp;

	tmp = p3->v0.x;
	if (p3->v1.x > tmp)	tmp = p3->v1.x;
	if (p3->v2.x > tmp)	tmp = p3->v2.x;
	if (tmp < (double)g_rcScreen.left)
		return	FALSE;
	if (tmp >= (double)g_rcScreen.right)
		bound->right = g_rcScreen.right-1;
	else
		bound->right = (long)tmp;

	tmp = p3->v0.y;
	if (p3->v1.y < tmp)	tmp = p3->v1.y;
	if (p3->v2.y < tmp)	tmp = p3->v2.y;
	if (tmp > (double)g_rcScreen.bottom)
		return	FALSE;
	if (tmp < (double)g_rcScreen.top){
		bound->top = g_rcScreen.top;
		top = (double)g_rcScreen.top;
	}else{
		top = tmp;
		bound->top = (long)tmp;
	}
	tmp = p3->v0.y;
	if (p3->v1.y > tmp)	tmp = p3->v1.y;
	if (p3->v2.y > tmp)	tmp = p3->v2.y;
	if (tmp < (double)g_rcScreen.top)
		return	FALSE;
	if (tmp >= (double)g_rcScreen.bottom){
		bottom = (double) g_rcScreen.bottom - 1;
		bound->bottom = g_rcScreen.bottom-1;
	}else{
		bottom = tmp;
		bound->bottom = (long)tmp;
	}
	if (fabs(bottom-top)<0.1)
		return	FALSE;
	return	TRUE;
}

/*
 *		ϊiXP[Oj
 */
static inline	TransConvertNS(Tex3NoShade3D *p3s, Poly3 *p3d);
static inline	TransConvertS(Tex3NoShade3D *p3s, Poly3 *p3d);
static inline	TransConvertNS(Tex3NoShade3D *p3s, Poly3 *p3d)
{
	p3d->v0.x = p3s->v0.x / p3s->v0.z;
	p3d->v0.y = p3s->v0.y / p3s->v0.z;
	p3d->v1.x = p3s->v1.x / p3s->v1.z;
	p3d->v1.y = p3s->v1.y / p3s->v1.z;
	p3d->v2.x = p3s->v2.x / p3s->v2.z;
	p3d->v2.y = p3s->v2.y / p3s->v2.z;
}
/*
 *		ϊiXP[OLj
 */
static inline	TransConvertS(Tex3NoShade3D *p3s, Poly3 *p3d)
{
	double				ctr_x, ctr_y;
	ctr_x = g_dbScreenCenterX;
	ctr_y = g_dbScreenCenterY;

	p3d->v0.x = p3s->v0.x / (p3s->v0.z - SCREEN_DISTANCE);
	p3d->v0.y = p3s->v0.y / (p3s->v0.z - SCREEN_DISTANCE);
	p3d->v0.x *= g_dbScreenScale;
	p3d->v0.y *= g_dbScreenScale;
	p3d->v0.x += ctr_x;
	p3d->v0.y = ctr_y - p3d->v0.y;

	p3d->v1.x = p3s->v1.x / (p3s->v1.z - SCREEN_DISTANCE);
	p3d->v1.y = p3s->v1.y / (p3s->v1.z - SCREEN_DISTANCE);
	p3d->v1.x *= g_dbScreenScale;
	p3d->v1.y *= g_dbScreenScale;
	p3d->v1.x += ctr_x;
	p3d->v1.y = ctr_y - p3d->v1.y;

	p3d->v2.x = p3s->v2.x / (p3s->v2.z - SCREEN_DISTANCE);
	p3d->v2.y = p3s->v2.y / (p3s->v2.z - SCREEN_DISTANCE);
	p3d->v2.x *= g_dbScreenScale;
	p3d->v2.y *= g_dbScreenScale;
	p3d->v2.x += ctr_x;
	p3d->v2.y = ctr_y - p3d->v2.y;
}
/*
 *	Op|S̓hԂij
 */
static	void	FillPoly3(Tex3NoShade3D *p3)
{
    DDSURFACEDESC2		ddsdTex,ddsdScreen;
    HRESULT				hres;
	Poly3				p3_2d;
	TransConvertS(p3,&p3_2d);
	if (CheckBack(&p3_2d))	return;

	ddsdTex.dwSize = sizeof(ddsdTex);
	ddsdScreen.dwSize = sizeof(ddsdScreen);
    while ((hres = g_pDDSOne->Lock(NULL, &ddsdTex, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	if (hres!=DD_OK){
		return;
	}
    while ((hres = g_pDDSOffScreen->Lock(NULL, &ddsdScreen, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	if (hres!=DD_OK){
		g_pDDSOne->Unlock(NULL);	return;
	}	
	if (
		(
		(ddsdTex.ddpfPixelFormat.dwRGBBitCount >> 3) 
				!= ((SCREEN_BIT_DEPTH+7)>>3)
		)
		||(
			(ddsdScreen.ddpfPixelFormat.dwRGBBitCount >> 3) 
				!= ((SCREEN_BIT_DEPTH+7)>>3)
		)
	){
		g_pDDSOne->Unlock(NULL);
		g_pDDSOffScreen->Unlock(NULL);
		return;
	}
	if ((fabs(p3->v1.z-p3->v0.z)<0.02)&&(fabs(p3->v2.z-p3->v0.z)<0.02)){
		FillPoly3_sub2D(&ddsdScreen,&ddsdTex,p3,&p3_2d);
	}else
		FillPoly3_sub(&ddsdScreen,&ddsdTex,p3,&p3_2d);
	g_pDDSOne->Unlock(NULL);
	g_pDDSOffScreen->Unlock(NULL);
}
#define	isBetween(a,b,c)	((c>b)?((a>=b)&&(a<=c)):((a>=c)&&(a<=b)))
#define	GetLineX(a,b,c,left,right,tmp)	\
	if (b.y==c.y){\
		if (b.x<c.x){if(b.x<left)(left=b.x);if(c.x>right)(right=c.x);}\
		else{if (c.x<left)(left=c.x); if (b.x>right)(right=b.x);}\
	}else{\
		tmp=b.x+(c.x-b.x)*((a-b.y)/(c.y-b.y));\
		if(tmp<left)(left=tmp);if(tmp>right)(right=tmp);\
	}
#define	ClipAbs1(a)	if (a < -1.0) a = -1.0; if (a > 1.0) a = 1.0;

static inline	void GetPoly3TexPos(Tex3NoShade3D *p3,double &tx,double &ty,double u,double v)
{
	double xo,yo,xp,yp;
	xo = p3->tv0.x + (p3->tv2.x - p3->tv0.x)*u;
	yo = p3->tv0.y + (p3->tv2.y - p3->tv0.y)*u;
	xp = p3->tv0.x + (p3->tv1.x - p3->tv0.x)*u;
	yp = p3->tv0.y + (p3->tv1.y - p3->tv0.y)*u;
	tx = xo+(xp-xo)*v;
	ty = yo+(yp-yo)*v;
}

static inline void	GetPoly3LeftRight(Poly3 *p3,RECT *bound,double line, double &dsx,double &dex)
{
	double left, right, tmp;
	left = (double)bound->right;	right = (double)bound->left;
	if (isBetween(line,p3->v0.y,p3->v2.y))
		GetLineX(line,p3->v0,p3->v2,left,right,tmp);
	if (isBetween(line,p3->v0.y,p3->v1.y))
		GetLineX(line,p3->v0,p3->v1,left,right,tmp);
	if (isBetween(line,p3->v1.y,p3->v2.y))
		GetLineX(line,p3->v1,p3->v2,left,right,tmp);
	(left > bound->left)?(dsx=left):(dsx=(double)bound->left);
	(right < bound->right)?(dex=right):(dex=(double)bound->right);
}

#if	SCREEN_BIT_DEPTH==8
#define	copypixel(p1,p2)	(*(BYTE*)p1=*(BYTE*)p2);
#else
#if SCREEN_BIT_DEPTH==16
#define	copypixel(p1,p2)	(*(unsigned short*)p1=*(unsigned short*)p2);
#endif
#endif

/*
 *		eNX`W̎Zo@̓A
 *		̑傫Ȃ̂IB
 */
#if	1
#define	CalcType(uType,vType)\
	uType=0;\
	if (fabs(M)>fabs(K)){\
		if (fabs(M)>fabs(L)){\
			uType=2;	/*	M > L > K, M > K > L	*/	\
		}else{\
			uType=1;	/*	L > M > K	*/	\
		}\
	}else{\
		if (fabs(L)>fabs(K)){\
			uType=1;	/*	L > K > M	*/\
		}\
		/*K > M > L, K > L > M*/\
	}\
	vType=0;\
	if (fabs(J)>fabs(F)){\
		if (fabs(J)>fabs(H)){\
			vType=2;	/*	J > H > F,  J > F > H	*/\
		}else{\
			vType=1;	/*	H > J > F	*/	\
		}\
	}else{\
		if (fabs(H)>fabs(F)){\
			vType=1;	/*	H > F > J	*/\
		}\
		/*	F > J > H,  F > H > J	*/\
	}
#else
#define	CalcType(uType,vType)\
	uType=0;\
	if (fabs(H)>fabs(F)){\
		uType=1;\
	}\
	vType=0;\
	if (fabs(J)>fabs(F)){\
		if (fabs(J)>fabs(H)){\
			vType=2;	/*	J > H > F,  J > F > H	*/\
		}else{\
			vType=1;	/*	H > J > F	*/	\
		}\
	}else{\
		if (fabs(H)>fabs(F)){\
			vType=1;	/*	H > F > J	*/\
		}\
		/*	F > J > H,  F > H > J	*/\
	}
#endif
/*
 *		eNX`W̎Zo
 *		Xy[X̓sɂ}N
 */
#define	GetPoly3UV(p3,Sx,Sy,u,v,tmpx,tmpy,tmpz)\
	if (flag1){\
		u = 0.0;	v = 0.0;\
	}else{\
	N = Sx*JL-SyJKpFLmHK;\
	if ((N>-0.00001)&&(N<0.00001)){\
		tmpz = p3->v0.z + p3->v1.z + p3->v2.z;\
		tmpz /= 3.0;\
	}else{\
		tmpz  = (Sx*SCREEN_DISTANCE+p3->v0.x)*JL;\
		tmpz -= FLmHKZ0;\
		tmpz -=(Sy*SCREEN_DISTANCE+p3->v0.y)*JK;\
		tmpz /= N;\
	}\
	tmpx = Sx*(tmpz-SCREEN_DISTANCE);\
	tmpy = Sy*(tmpz-SCREEN_DISTANCE);\
	switch(uType){\
		case	0:\
			u = (tmpx-p3->v0.x)*J-(tmpz-p3->v0.z)*F;\
			u /= K;\
			break;\
		case	1:\
			u = (tmpy-p3->v0.y)*J-(tmpz-p3->v0.z)*H;\
			u /= L;\
			break;\
		default:\
			u = (tmpx-p3->v0.x)*H-(tmpy-p3->v0.y)*F;\
			u /= M;\
			break;\
	}\
	if (u <= 0.0){	\
		u = 0.0;	v = 0;	return;\
	}\
	if (u>1.0)	u = 1.0;\
	switch(vType){\
		case	0:\
			v = tmpx-p3->v0.x-E*u;\
			v /= u*F;\
			break;\
		case	1:\
			v = tmpy-p3->v0.y-G*u;\
			v /= u*H;\
			break;\
		default:\
			v = tmpz-p3->v0.z-I*u;\
			v /= u*J;\
			break;\
	}\
	if (v<0.0)	v = 0.0;\
	if (v>1.0)	v = 1.0;\
	}

/*
 *		_f[^̍œKB
 *		Z̍WvZ₷悤ɍœKB
 */
static	inline	void	OptimizePoly3(Tex3NoShade3D *p3d, Tex3NoShade3D *p3s);
static	inline	void	OptimizePoly3(Tex3NoShade3D *p3d, Tex3NoShade3D *p3s)
{
	double	J;
	J = fabs(p3s->v0.z-p3s->v1.z);
	if (fabs(p3s->v1.z - p3s->v2.z)<J){
		if (J>fabs(p3s->v0.z-p3s->v2.z)){
			p3d->v0=p3s->v2;
			p3d->v1=p3s->v1;
			p3d->v2=p3s->v0;
			p3d->tv0=p3s->tv2;
			p3d->tv1=p3s->tv1;
			p3d->tv2=p3s->tv0;
		}else{
			p3d->v0=p3s->v1;
			p3d->v1=p3s->v0;
			p3d->v2=p3s->v2;
			p3d->tv0=p3s->tv1;
			p3d->tv1=p3s->tv0;
			p3d->tv2=p3s->tv2;
		}
	}else{
		*p3d=*p3s;
	}
}
/*
 *	Op|S̓hԂisNZj
 */
static	void	DoHorizont(BYTE *pixelPtr, int screenPitch, int pixelLength)
{
}

static	void	FillPoly3_sub(DDSURFACEDESC2 *ddsdScreen,DDSURFACEDESC2 *ddsdTex,Tex3NoShade3D *p3s,Poly3 *p3_2d)
{
	RECT	bound;
	int		x, y, sx,ex;
	double	E,F,G,H,I,J,K,L,M,N;
	double	JL,FL,HK,JK;
	double	dsx,dex;
	fVertex	start, end;
	double				ctr_x, ctr_y;
	double	screenScaleInv = 1.0/g_dbScreenScale;
	BOOL	flag1,flag2;
	int		uType,vType;
	Tex3NoShade3D	*p3,p3c;	
	ctr_x = g_dbScreenCenterX;
	ctr_y = g_dbScreenCenterY;

	OptimizePoly3(p3=&p3c,p3s);
	if (!GetPoly3Boundary(&bound,p3_2d))	return;

	E = p3->v2.x - p3->v0.x;	F = p3->v1.x - p3->v2.x;
	G = p3->v2.y - p3->v0.y;	H = p3->v1.y - p3->v2.y;
	I = p3->v2.z - p3->v0.z;	J = p3->v1.z - p3->v2.z;
	K = (E*J)-(F*I);		L = (G*J)-(H*I);	M = (E*H)-(F*G);
	JL = J*L;	FL = F*L;	HK = H*K;	JK = J*K;
	flag1 = ((fabs(K)<0.00001)&&(fabs(L)<0.00001)&&(fabs(M)<0.00001));
	flag2 = ((fabs(F)<0.00001)&&(fabs(H)<0.00001)&&(fabs(J)<0.00001));
	CalcType(uType,vType);
	int		screenPitch;
	BYTE	*texBase, *screenBase, *pixelPtr,*ptr;
	long	texpixelsize=ddsdTex->ddpfPixelFormat.dwRGBBitCount >> 3;
	long	texlinesize=ddsdTex->lPitch;
	double	Sx,Sy,line,XD,ZD,tmpz,tmpx;
	double	XDinv, ZDinv;
	double	u,v,tx0,ty0,tdx,tdy;
	double	FLmHK;
	double	FLmHKZ0;
	double	SyJKpFLmHK;
	FLmHK = FL-HK;
	FLmHKZ0 = FLmHK*p3->v0.z;
	texBase = (BYTE*)ddsdTex->lpSurface;
	screenBase = (BYTE*)ddsdScreen->lpSurface;
	screenBase += ddsdScreen->lPitch * bound.top;
	screenPitch= ddsdScreen->ddpfPixelFormat.dwRGBBitCount/8;

	for (y = bound.top; y <= bound.bottom ; ++y,screenBase += ddsdScreen->lPitch){
		line =(double)y;
		GetPoly3LeftRight(p3_2d,&bound,line,dsx,dex);
		if ((dex-dsx) <= 0.1)
			continue;
		sx = (int)dsx;	ex = (int)dex;
		Sy = (ctr_y-line)/g_dbScreenScale;
		SyJKpFLmHK=Sy*JK+FLmHK;
		Sx = (dsx-ctr_x)/g_dbScreenScale;
		GetPoly3UV(p3,Sx,Sy,u,v,start.x,start.y,start.z);
		GetPoly3TexPos(p3,tx0,ty0,u,v);
		Sx = (dex-ctr_x)/g_dbScreenScale;
		GetPoly3UV(p3,Sx,Sy,u,v,end.x,end.y,end.z);
		GetPoly3TexPos(p3,tdx,tdy,u,v);
		pixelPtr = screenBase + (screenPitch*sx);
		XD = end.x - start.x;
		XDinv=1.0/XD;
		ZD = end.z - start.z;
		ZDinv=1.0/ZD;
		ex -= sx;
		tdx -= tx0;
		tdy -= ty0;
		tx0 += 0.5;
		ty0 += 0.5;
		tmpx = ((double)dsx) - ctr_x;
		if (fabs(ZD)>fabs(XD)){
			register double	tmp_above = XD*start.z-start.x*ZD, t;
			//	wc̏
			for (x = 0; x <= ex; ++x,pixelPtr += screenPitch){
				Sx = tmpx*screenScaleInv;	tmpx += 1.0;
				tmpz = tmp_above-Sx*ZD*SCREEN_DISTANCE;
				tmpz /= XD - ZD*Sx;
				t = tmpz - start.z;
				t *= ZDinv;
				if (t < 0)	t=0;
				if (t > 1.0)	t = 1.0;
				ptr = texBase;
				ptr += texlinesize * (int)(tdy * t + ty0);
				ptr += texpixelsize * (int)(tdx * t + tx0);
				copypixel(pixelPtr,ptr);
			}
		}else{
			register double	tmp_above = XD*start.z-start.x*ZD, t;
			for (x = 0; x <= ex; ++x,pixelPtr += screenPitch){
				Sx = tmpx*screenScaleInv;	tmpx += 1.0;
				tmpz = tmp_above-Sx*ZD*SCREEN_DISTANCE;
				tmpz /= XD - ZD*Sx;
				t = Sx*(tmpz-SCREEN_DISTANCE) - start.x;
				t *= XDinv;
				if (t < 0)	t=0;
				if (t > 1.0)	t = 1.0;
				ptr = texBase;
				ptr += texlinesize * (int)(tdy * t + ty0);
				ptr += texpixelsize * (int)(tdx * t + tx0);
				copypixel(pixelPtr,ptr);
			}
		}
	}
}

#define	GetPoly3UV2D(p3,px,py,u,v,flag)\
	u = (px - p3->v0.x)*H - (py - p3->v0.y)*F;\
	u /= EHmFG;\
	if ((u>-0.00001)&&(u < 0.00001))	v = 0;\
	else (flag)?(v =(px-p3->v0.x-u*E)/(u*F)):(v=(py-p3->v0.y-u*G)/(u*H));\
	if (u < 0.0)	u = 0;\
	if (u > 1.0)	u = 1.0;\
	if (v < 0.0)	v = 0.0;\
	if (v > 1.0)	v = 1.0;
/*
 *		O_̂ylقړ́AQc
 */
/*
 *	Op|S̓hԂisNZj
 */
static	void	FillPoly3_sub2D(DDSURFACEDESC2 *ddsdScreen,DDSURFACEDESC2 *ddsdTex,Tex3NoShade3D *p3,Poly3 *p3_2d)
{
	RECT	bound;
	int		x, y,tx,ty, sx,ex;
	double	E,F,G,H,u,v,tx0,ty0,tdx,tdy;
	double	EHmFG,tmp,dsx,dex;
	BOOL	flag;
	int		screenPitch;
	BYTE	*texBase, *screenBase, *pixelPtr,*ptr;
	long	texpixelsize=ddsdTex->ddpfPixelFormat.dwRGBBitCount >> 3;
	long	texlinesize=ddsdTex->lPitch;

	if (!GetPoly3Boundary(&bound,p3_2d))	return;

	texBase = (BYTE*)ddsdTex->lpSurface;
	screenBase = (BYTE*)ddsdScreen->lpSurface;
	screenBase += ddsdScreen->lPitch * bound.top;
	screenPitch= ddsdScreen->ddpfPixelFormat.dwRGBBitCount/8;

	if (!GetPoly3Boundary(&bound,p3_2d))	return;
	E = p3_2d->v2.x - p3_2d->v0.x;	F = p3_2d->v1.x - p3_2d->v2.x;
	G = p3_2d->v2.y - p3_2d->v0.y;	H = p3_2d->v1.y - p3_2d->v2.y;
	EHmFG=(E*H)-(F*G);
	flag = (fabs(F)>fabs(H));

	if ((EHmFG>=0.00001)||(EHmFG<=-0.00001)){
		for (y = bound.top; y <= bound.bottom ; ++y,screenBase += ddsdScreen->lPitch){
			double	line =(double)y;
			GetPoly3LeftRight(p3_2d,&bound,line,dsx,dex);
			if ((dex-dsx) <= 0.5)
				continue;
			sx = (int)dsx;	ex = (int)dex;

			GetPoly3UV2D(p3_2d,dsx,line,u,v,flag);
			GetPoly3TexPos(p3,tx0,ty0,u,v);
			GetPoly3UV2D(p3_2d,dex,line,u,v,flag);
			GetPoly3TexPos(p3,tdx,tdy,u,v);
			pixelPtr = screenBase + (screenPitch*sx);
			ex -= sx;
			tdx -= tx0;
			tdy -= ty0;
			tx0 += 0.5;	//	for rounding up numbers above 5.
			ty0 += 0.5;	//	for rounding up numbers above 5.
			tmp = (double)ex;
			dsx = 0.0;
			for(x = 0; x <= ex; ++x,pixelPtr+=screenPitch){
				dex = dsx/tmp;	dsx += 1.0;
				tx = (long)(tx0+(tdx*dex));
				ty = (long)(ty0+(tdy*dex));
				ptr = texBase;
				ptr += texlinesize * ty;
				ptr += texpixelsize * tx;
				copypixel(pixelPtr,ptr);
			}
		}
	}
}

/*
 *
 *		ȉׂāArcjt̃Tv
 *		ʂ
 *
 */

static DWORD
DDColorPick(IDirectDrawSurface4 * pdds, int x, int y)
{
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;
	BYTE	*ptr;
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
		ptr = (BYTE*)ddsd.lpSurface;
		ptr += ddsd.lPitch * y;
		ptr += (ddsd.ddpfPixelFormat.dwRGBBitCount / 8) * x;
        dw = *(DWORD *)ptr;		// Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        pdds->Unlock(NULL);
    }
    return dw;
}


extern "C" HRESULT
DDSetColorKeyFromPoint(IDirectDrawSurface4 * pdds, int x, int y)
{
	DDCOLORKEY	ddck;
    ddck.dwColorSpaceLowValue = DDColorPick(pdds, x, y);
    ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
    return pdds->SetColorKey(DDCKEY_SRCBLT, &ddck);
}

//-----------------------------------------------------------------------------
// Name: DDLoadBitmap()
// Desc: Create a DirectDrawSurface from a bitmap resource.
//-----------------------------------------------------------------------------
extern "C" IDirectDrawSurface4 *
DDLoadBitmap(IDirectDraw4 * pdd, LPCSTR szBitmap, int dx, int dy)
{
    HBITMAP                 hbm;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    IDirectDrawSurface4    *pdds;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, dx,
                              dy, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, dx, dy,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
        return NULL;
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    //
    // Create a DirectDrawSurface for this bitmap
    //
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN|DDSCAPS_SYSTEMMEMORY;
    ddsd.dwWidth = bm.bmWidth;
    ddsd.dwHeight = bm.bmHeight;
    if (pdd->CreateSurface(&ddsd, &pdds, NULL) != DD_OK)
        return NULL;
    DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
    DeleteObject(hbm);
    return pdds;
}

//-----------------------------------------------------------------------------
// Name: DDReLoadBitmap()
// Desc: Load a bitmap from a file or resource into a directdraw surface.
//       normaly used to re-load a surface after a restore.
//-----------------------------------------------------------------------------
HRESULT
DDReLoadBitmap(IDirectDrawSurface4 * pdds, LPCSTR szBitmap)
{
    HBITMAP                 hbm;
    HRESULT                 hr;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, 0,
                              0, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, 0, 0,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
    {
        return E_FAIL;
    }
    hr = DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
//  if (hr != DD_OK)
//	{
//		TRACE("ddcopybitmap failed\n");
//	}
    DeleteObject(hbm);
    return hr;
}

//-----------------------------------------------------------------------------
// Name: DDCopyBitmap()
// Desc: Draw a bitmap into a DirectDrawSurface
//-----------------------------------------------------------------------------
extern "C" HRESULT
DDCopyBitmap(IDirectDrawSurface4 * pdds, HBITMAP hbm, int x, int y,
             int dx, int dy)
{
    HDC                     hdcImage;
    HDC                     hdc;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hr;

    if (hbm == NULL || pdds == NULL)
        return E_FAIL;
    //
    // Make sure this surface is restored.
    //
    pdds->Restore();
    //
    // Select bitmap into a memoryDC so we can use it.
    //
    hdcImage = CreateCompatibleDC(NULL);
//    if (!hdcImage)
//        TRACE("createcompatible dc failed\n");
    SelectObject(hdcImage, hbm);
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    dx = dx == 0 ? bm.bmWidth : dx;     // Use the passed size, unless zero
    dy = dy == 0 ? bm.bmHeight : dy;
    //
    // Get size of surface.
    //
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH;
    pdds->GetSurfaceDesc(&ddsd);

    if ((hr = pdds->GetDC(&hdc)) == DD_OK)
    {
        StretchBlt(hdc, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hdcImage, x, y,
                   dx, dy, SRCCOPY);
        pdds->ReleaseDC(hdc);
    }
    DeleteDC(hdcImage);
    return hr;
}

//-----------------------------------------------------------------------------
// Name: DDLoadPalette()
// Desc: Create a DirectDraw palette object from a bitmap resource
//       if the resource does not exist or NULL is passed create a
//       default 332 palette.
//-----------------------------------------------------------------------------
extern "C" IDirectDrawPalette *
DDLoadPalette(IDirectDraw4 * pdd, LPCSTR szBitmap)
{
    IDirectDrawPalette     *ddpal;
    int                     i;
    int                     n;
    int                     fh;
    HRSRC                   h;
    LPBITMAPINFOHEADER      lpbi;
    PALETTEENTRY            ape[256];
    RGBQUAD                *prgb;

    //
    // Build a 332 palette as the default.
    //
    for (i = 0; i < 256; i++)
    {
        ape[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        ape[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        ape[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        ape[i].peFlags = (BYTE) 0;
    }
    //
    // Get a pointer to the bitmap resource.
    //
    if (szBitmap && (h = FindResource(NULL, szBitmap, RT_BITMAP)))
    {
        lpbi = (LPBITMAPINFOHEADER) LockResource(LoadResource(NULL, h));
//        if (!lpbi)
//            TRACE("lock resource failed\n");
        prgb = (RGBQUAD *) ((BYTE *) lpbi + lpbi->biSize);
        if (lpbi == NULL || lpbi->biSize < sizeof(BITMAPINFOHEADER))
            n = 0;
        else if (lpbi->biBitCount > 8)
            n = 0;
        else if (lpbi->biClrUsed == 0)
            n = 1 << lpbi->biBitCount;
        else
            n = lpbi->biClrUsed;
        //
        //  A DIB color table has its colors stored BGR not RGB
        //  so flip them around.
        //
        for (i = 0; i < n; i++)
        {
            ape[i].peRed = prgb[i].rgbRed;
            ape[i].peGreen = prgb[i].rgbGreen;
            ape[i].peBlue = prgb[i].rgbBlue;
            ape[i].peFlags = 0;
        }
    }
    else if (szBitmap && (fh = _lopen(szBitmap, OF_READ)) != -1)
    {
        BITMAPFILEHEADER        bf;
        BITMAPINFOHEADER        bi;

        _lread(fh, &bf, sizeof(bf));
        _lread(fh, &bi, sizeof(bi));
        _lread(fh, ape, sizeof(ape));
        _lclose(fh);
        if (bi.biSize != sizeof(BITMAPINFOHEADER))
            n = 0;
        else if (bi.biBitCount > 8)
            n = 0;
        else if (bi.biClrUsed == 0)
            n = 1 << bi.biBitCount;
        else
            n = bi.biClrUsed;
        //
        //  A DIB color table has its colors stored BGR not RGB
        //  so flip them around.
        //
        for (i = 0; i < n; i++)
        {
            BYTE        r = ape[i].peRed;

            ape[i].peRed = ape[i].peBlue;
            ape[i].peBlue = r;
        }
    }
    pdd->CreatePalette(DDPCAPS_8BIT, ape, &ddpal, NULL);
    return ddpal;
}




//-----------------------------------------------------------------------------
// Name: DDColorMatch()
// Desc: Convert a RGB color to a pysical color.
//       We do this by leting GDI SetPixel() do the color matching
//       then we lock the memory and see what it got mapped to.
//-----------------------------------------------------------------------------
extern "C" DWORD
DDColorMatch(IDirectDrawSurface4 * pdds, COLORREF rgb)
{
    COLORREF                rgbT;
    HDC                     hdc;
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;

    //
    //  Use GDI SetPixel to color match for us
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, rgb);       // Set our value
        pdds->ReleaseDC(hdc);
    }
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface;                 // Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        pdds->Unlock(NULL);
    }
    //
    //  Now put the color that was there back.
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        pdds->ReleaseDC(hdc);
    }
    return dw;
}



//-----------------------------------------------------------------------------
// Name: DDSetColorKey()
// Desc: Set a color key for a surface, given a RGB.
//       If you pass CLR_INVALID as the color key, the pixel
//       in the upper-left corner will be used.
//-----------------------------------------------------------------------------
extern "C" HRESULT
DDSetColorKey(IDirectDrawSurface4 * pdds, COLORREF rgb)
{
    DDCOLORKEY              ddck;

    ddck.dwColorSpaceLowValue = DDColorMatch(pdds, rgb);
    ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
    return pdds->SetColorKey(DDCKEY_SRCBLT, &ddck);
}

