/*
 *	e[ubNAbv^̎Op֐
 *
 *		First edition:	May.02.2001
 *		Author:			Yohei Kishimoto
 */
#include <math.h>
#include "trifunc.h"

#define	PI	(3.1415926)
static TRIFUNC_DATATYPE sine_values[SINE_STEP];

void InitTrifuncs()
{
	double tmp;
	int	i;
	for(i=0;i<SINE_STEP;++i){
		tmp=(double)i;
		tmp/=(double)SINE_STEP;
		tmp*=(2.0*PI);
		sine_values[i]
			= (TRIFUNC_DATATYPE)sin(tmp);
	}
}

TRIFUNC_DATATYPE sin_fast(int t)
{
	if (t < 0){
		t = SINE_STEP - ((-t)%SINE_STEP);
	}else{
		t%=SINE_STEP;
	}
	return(sine_values[t]);
}
TRIFUNC_DATATYPE cos_fast(int t)
{
	t+= (SINE_STEP/4);
	if (t < 0){
		t = SINE_STEP - ((-t)%SINE_STEP);
	}else{
		t%=SINE_STEP;
	}
	return(sine_values[t]);
}
