// MeshTest.cpp: CMeshTest NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <d3d8.h>
#include <d3dx8.h>
#include "GameMain.h"
#include "MeshTest.h"
#include <tchar.h>
static void GetFileName(TCHAR *str);
static void GetAppPathName(TCHAR *strCmdPath);


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
static void GetFileName(TCHAR *str)
{
    int     l,i;
    TCHAR    *c;
    l = strlen(str);
    if ((str[0]=='\"')&&(str[l-1]=='\"')){
        for(i = 0; i < (l - 1) ; ++i){
            str[i] = str[i+1];
        }
        --l;
        str[l] = 0;
    }
    c = strrchr(str,'\\');
    if (c){
        c++;
        i = 0;
        while('\0' != (str[i++] = *c++));
    } 
}

static void GetAppPathName(TCHAR *strCmdPath)
{
	int l,i;
	TCHAR *str = strCmdPath,*c;
	lstrcpy( str, ::GetCommandLine());  // NAvP[V̐΃pX擾B 
	l = strlen(str);
	if (str[0]=='\"'){
		for(i = 0; i < l; ++i){
			str[i] = str[i+1];
		}
		--l;
	}  // " Ŏn܂ĂAꕶ߂B 
	c = strrchr(str,'\\');
	if (c){
		*c=0;
	}else{ 
		strCmdPath[0]=0;
	}
} 

CMeshTest::CMeshTest()
{
    GetAppPathName(m_strMeshPath);
    m_dwNumMaterials = 0;
    m_pMaterials = NULL;
    m_pMeshEnhanced = NULL;
    m_pMeshSysMem = NULL;
    m_ppTextures = NULL;
    m_bUseHWNPatches = FALSE;
    m_dwNumSegs = 2;
	m_ppFilenames = NULL;		//
	m_pFilenameBuffer = NULL;	//
    m_fAngleY = 0.0f;
}

CMeshTest::~CMeshTest()
{
	this->InvalidateDeviceObjects();
	this->DeleteDeviceObjects();
}

HRESULT	CMeshTest::InitDeviceObjects(LPDIRECT3DDEVICE8 lpd3ddev)
{
    LPDIRECT3DVERTEXBUFFER8 pVB = NULL;
    BYTE*      pVertices = NULL;
    LPD3DXMESH pTempMesh;
    HRESULT    hr;
    TCHAR    strMeshFilename[512];

  
    InvalidateDeviceObjects();
    DeleteDeviceObjects();

	LPD3DXBUFFER	pMtrlBuffer=NULL;
    _tcscpy(strMeshFilename,m_strMeshPath);
    _tcscat(strMeshFilename,"\\");
    _tcscat(strMeshFilename,"smile.x");
    hr = D3DXLoadMeshFromX( strMeshFilename, D3DXMESH_SYSTEMMEM, lpd3ddev, 
        NULL, &pMtrlBuffer, &m_dwNumMaterials, 
        &m_pMeshSysMem );
    if (FAILED(hr)){
        return    hr;
    }

    hr = m_pMeshSysMem->GetVertexBuffer( &pVB );
    if( FAILED(hr) )
        return hr;
    hr = pVB->Lock( 0, 0, &pVertices, 0 );
    if( FAILED(hr) ){
        if ( pVB != NULL){ pVB->Release();	pVB=NULL;	}
        return hr;
    }
    hr = D3DXComputeBoundingSphere( pVertices, m_pMeshSysMem->GetNumVertices(), 
                                    m_pMeshSysMem->GetFVF(), &m_vObjectCenter, 
                                    &m_fObjectRadius );
    pVB->Unlock();
    if ( pVB != NULL){ pVB->Release(); pVB=NULL;	}
    if( FAILED(hr) ){
        return hr;
    }

    if( 0 == m_dwNumMaterials ){
        return E_FAIL;
    }
	D3DXMATERIAL	*pMaterial;
	pMaterial = (D3DXMATERIAL*)pMtrlBuffer->GetBufferPointer();
    m_pMaterials = new D3DMATERIAL8[m_dwNumMaterials];
    m_ppFilenames = new LPSTR[m_dwNumMaterials];
    m_ppTextures = new LPDIRECT3DTEXTURE8[m_dwNumMaterials];
    ZeroMemory(m_ppTextures,sizeof(LPDIRECT3DTEXTURE8)*m_dwNumMaterials);
	//	}eARs[ĕۑB
	int	len = 0;
	for (DWORD i = 0; i < m_dwNumMaterials ; ++i){
		if (pMaterial[i].pTextureFilename!= NULL){
			len += strlen(pMaterial[i].pTextureFilename);
			len++;
		}
		m_pMaterials[i] = pMaterial[i].MatD3D;
		m_pMaterials[i].Ambient = m_pMaterials[i].Diffuse;
	}
	//	eNX`t@Cl[Rs[ĕۑB
	LPSTR	p1, p2;
	p1 = m_pFilenameBuffer = new TCHAR[len];
	for (i = 0; i < m_dwNumMaterials; ++i){
		p2 = pMaterial[i].pTextureFilename;
		if (p2 == NULL){
			m_ppFilenames[i] = NULL;
		}else{
			m_ppFilenames[i] = p1;
			while(NULL != (*p1++ = *p2++));
		}
	}
	SAFE_RELEASE(pMtrlBuffer);

    // Make sure there are normals, which are required for the tesselation
    // enhancement (_tH[}bg̏C)
    if( !(m_pMeshSysMem->GetFVF() & D3DFVF_NORMAL) )
    {
        hr = m_pMeshSysMem->CloneMeshFVF( m_pMeshSysMem->GetOptions(), 
                                          m_pMeshSysMem->GetFVF() | D3DFVF_NORMAL, 
                                          lpd3ddev, &pTempMesh );
        if( FAILED(hr) )
            return hr;
#if D3D_SDK_VERSION >= 220
        D3DXComputeNormals( pTempMesh, NULL );
#else
        D3DXComputeNormals( pTempMesh );
#endif
        if ( m_pMeshSysMem != NULL)
            m_pMeshSysMem->Release();
        m_pMeshSysMem = pTempMesh;
    }
    return S_OK;

}

HRESULT CMeshTest::RestoreDeviceObjects(LPDIRECT3DDEVICE8 lpd3ddev)
{
    HRESULT    hr;
    D3DCAPS8    d3dCaps;

    InvalidateDeviceObjects();
    if (m_pMeshSysMem == NULL){
        return E_FAIL;
    }

    lpd3ddev->GetDeviceCaps(&d3dCaps);

    for( UINT i=0; i < m_dwNumMaterials; i++ )
    {
        TCHAR tmp[512];
        TCHAR strTexturePath[512] = _T("");
		if (m_ppFilenames[i] == NULL){
			m_ppTextures[i] = NULL;
			continue;
		}
        strcpy( tmp, m_ppFilenames[i] );
        GetFileName(tmp);
        _tcscpy(strTexturePath,m_strMeshPath );
        _tcscat(strTexturePath,"\\");
        _tcscat(strTexturePath,tmp);
        if( FAILED( D3DXCreateTextureFromFile( lpd3ddev, strTexturePath, 
                                               &m_ppTextures[i] ) ) )
            m_ppTextures[i] = NULL;
    }

    m_bUseHWNPatches = (d3dCaps.DevCaps & D3DDEVCAPS_NPATCHES);
	hr = GenerateEnhancedMesh( lpd3ddev, m_dwNumSegs );
    if( FAILED(hr) )
        return hr;
    return S_OK;
}

HRESULT CMeshTest::GenerateEnhancedMesh( LPDIRECT3DDEVICE8 lpd3ddev, UINT dwNewNumSegs )
{
    LPD3DXMESH pMeshEnhancedSysMem = NULL;
    LPD3DXMESH pMeshTemp;
    HRESULT    hr;

    if (m_bUseHWNPatches){
        // n[hEFAT|[gȂA|S𕪊ărfIJ[hցB
        hr = m_pMeshSysMem->CloneMeshFVF( D3DXMESH_WRITEONLY | D3DXMESH_NPATCHES, 
                                m_pMeshSysMem->GetFVF(), lpd3ddev, &pMeshTemp );
        if( FAILED(hr) )
            return hr;
    }else{
        // n[hEFAT|[gȂA_f[^rfIJ[hցB
        hr = m_pMeshSysMem->CloneMeshFVF( D3DXMESH_WRITEONLY, 
                                 m_pMeshSysMem->GetFVF(), lpd3ddev, &pMeshTemp );
		//	\tgEFAeZ[V͏ȗB
    }
    if (m_pMeshEnhanced != NULL){
        m_pMeshEnhanced->Release();
        m_pMeshEnhanced = NULL;
    }
    
    m_pMeshEnhanced = pMeshTemp;
    m_dwNumSegs     = dwNewNumSegs;
    return S_OK;
}

HRESULT CMeshTest::InvalidateDeviceObjects()
{
    if (m_pMeshEnhanced != NULL){
        m_pMeshEnhanced->Release();
        m_pMeshEnhanced = NULL;
    }
    if (m_ppTextures != NULL){
        for( UINT i = 0; i < m_dwNumMaterials; i++ ){
            if (m_ppTextures[i] != NULL){
                m_ppTextures[i]->Release();
                m_ppTextures[i] = NULL;
            }
        }
	}
    return  S_OK;
}

HRESULT CMeshTest::DeleteDeviceObjects()
{
    if (m_ppTextures != NULL){
        delete [] m_ppTextures;
        m_ppTextures = NULL;
    }
	if (m_pMaterials != NULL){
        delete [] m_pMaterials;
        m_pMaterials = NULL;
	}
	if (m_ppFilenames != NULL){
        delete [] m_ppFilenames;
        m_ppFilenames = NULL;
	}
	if (m_pFilenameBuffer != NULL){
        delete [] m_pFilenameBuffer;
        m_pFilenameBuffer = NULL;
	}
    if (m_pMeshSysMem != NULL){
        m_pMeshSysMem->Release();
        m_pMeshSysMem = NULL;
    }
    m_dwNumMaterials = 0L;
    return  S_OK;
}

void    CMeshTest::Update(float timeElapsed)
{
    D3DXMATRIX    matTrans, matRotateY;
    m_fAngleY += timeElapsed * (D3DX_PI / 240.0f);
    if (m_fAngleY > D3DX_PI*2.0f)
        m_fAngleY -= D3DX_PI*2.0f;
    D3DXMatrixRotationY(&matRotateY,m_fAngleY);
    D3DXMatrixTranslation(&matTrans,0.0f,0.0f,1.0f);
    m_matWorld =  matRotateY * matTrans;
}

void    CMeshTest::Render(LPDIRECT3DDEVICE8 lpd3ddev)
{
    lpd3ddev->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
    lpd3ddev->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
    lpd3ddev->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
    lpd3ddev->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG2);
    lpd3ddev->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE);

    lpd3ddev->SetRenderState(D3DRS_ALPHABLENDENABLE,FALSE);
    lpd3ddev->SetRenderState(D3DRS_LIGHTING, TRUE );
    lpd3ddev->SetTransform( D3DTS_WORLD, &m_matWorld );
    if (m_bUseHWNPatches){
        float fNumSegs;
        fNumSegs = (float)m_dwNumSegs;
        lpd3ddev->SetRenderState(D3DRS_PATCHSEGMENTS, *((DWORD*)&fNumSegs));
    }
    if (m_pMeshEnhanced){
        for( UINT i = 0; i < m_dwNumMaterials; i++ ){
            lpd3ddev->SetMaterial( &m_pMaterials[i] );
            lpd3ddev->SetTexture( 0, m_ppTextures[i] );
            m_pMeshEnhanced->DrawSubset( i );
        }
    }
    if (m_bUseHWNPatches){
        lpd3ddev->SetRenderState(D3DRS_PATCHSEGMENTS, 0);
    }
}

