/*
 *		  This program handles high resolution timer
 *		which uses 64-bit CPU based counter, through 
 *		windows API.
 *		  This program may not run correctly under some 
 *		dual CPU systems because each CPU has an independent
 *		CPU clock.
 *
 *		First edition: August.12.2002
 */

#include "stdafx.h"
#include "HighResTimer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//-------------------------------------------------------
// Name: CHighResTimer
// Desc: NX CHighResTimer RXgN^
//-------------------------------------------------------
CHighResTimer::CHighResTimer()
{
    Reset();
}

//-------------------------------------------------------
// Name: CHighResTimer
// Desc: NX CHighResTimer fXgN^
//-------------------------------------------------------
CHighResTimer::~CHighResTimer()
{

}

//-------------------------------------------------------
// Name: Reset
// Desc: ^C}l̃Zbg
//-------------------------------------------------------
void    CHighResTimer::Reset()
{
    LARGE_INTEGER   liFreq;
    int             i60 = 60;
    ::QueryPerformanceFrequency(&liFreq);
    __asm{
        fild    i60                     ;
        fild    liFreq.QuadPart         ;
        fdivp   st(1), st(0)            ;
        mov     esi, this
        fstp    double ptr [esi].m_dbFrequency    ;
    }
    ::QueryPerformanceCounter(&m_liCounter);
}

//-------------------------------------------------------
// Name: GetElapsedTime
// Desc: oߎԂ̎擾
//-------------------------------------------------------
float    CHighResTimer::GetElapsedTime()
{
    LARGE_INTEGER  tmp, old;
    float          frame;
    ::QueryPerformanceCounter(&tmp);
    old.QuadPart = m_liCounter.QuadPart;
    __asm{
        mov     eax, tmp.LowPart;
        mov     edx, tmp.HighPart;
        sub     eax, old.LowPart;
        sbb     edx, old.HighPart;
        mov     tmp.LowPart, eax;
        mov     tmp.HighPart, edx;

        fild    tmp.QuadPart;
        mov     esi, this
        fmul    double ptr [esi].m_dbFrequency;
        fstp    frame;
    }
    return    frame;
}

//-------------------------------------------------------
// Name: GetElapsedTimeAndReset
// Desc: oߎԂ擾ă^C}Zbg
//-------------------------------------------------------
float    CHighResTimer::GetElapsedTimeAndReset()
{
    LARGE_INTEGER  tmp, old;
    float          frame;
    ::QueryPerformanceCounter(&tmp);
    old.QuadPart = m_liCounter.QuadPart    ;
    m_liCounter.QuadPart = tmp.QuadPart    ;
    __asm{
        mov     eax, tmp.LowPart;
        mov     edx, tmp.HighPart;
        sub     eax, old.LowPart;
        sbb     edx, old.HighPart;
        mov     tmp.LowPart, eax;
        mov     tmp.HighPart, edx;

        fild    tmp.QuadPart;
        mov     esi, this
        fmul    double ptr [esi].m_dbFrequency;
        fstp    frame;
    }
    return    frame;
}
