#ifndef	__GameMain_h__
#define	__GameMain_h__

enum	APPMSGTYPE { MSG_NONE, MSGERR_APPMUSTEXIT, MSGWARN_SWITCHEDTOREF };
#define	SAFE_RELEASE(o)	{if (o){	(o)->Release(); (o) = NULL;	}}
#define	SAFE_DELETE(o)	{if (o){	delete (o); (o) = NULL;	}}
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }

void	InitD3D(HWND hWnd);
void	InitFail(HWND hWnd, LPCTSTR szError,...);
void	ReleaseD3D();
void	UpdateScreen();
void	SetDefaultRenderState(LPDIRECT3DDEVICE8 lpd3ddev);
HRESULT	InitDeviceObjects();
HRESULT	InvalidateDeviceObjects();
HRESULT	RestoreDeviceObjects();
HRESULT	DeleteDeviceObjects();
HRESULT Resize3DEnvironment();
HRESULT UserAdjustWindow();
HRESULT ToggleFullscreen();
HRESULT ForceWindowed();
HRESULT	ForceFullscreen();
HRESULT AdjustWindowForChange();
HRESULT UserSelectNewDevice();
void	AdjustCursor();

extern	D3DCAPS8		g_CurrentDeviceCaps;
extern	D3DXMATRIX		g_matView;
extern	D3DXMATRIX		g_matProj;
extern	D3DXVECTOR3		g_vecLight;
extern	LPDIRECT3D8			g_lpD3D;
extern	LPDIRECT3DDEVICE8	g_lpD3DDEV;
extern	RECT				g_rcWindowClient;

extern	BOOL				g_bUseDepthBuffer;
extern	BOOL				g_bWindowed;
extern	D3DCOLOR			g_bgColor;
extern	D3DPRESENT_PARAMETERS	g_d3dprm;

#define	GetSystemView()	(&g_matView)
#define	GetSystemProjection()	(&g_matProj)
#define	GetSystemLightDirection()	(&g_vecLight)
#define	GetCurrentDeviceCaps()	(&g_CurrentDeviceCaps)
#define	GetD3DPresentParameters()	(&g_d3dprm)
#define	GetD3D()			(g_lpD3D)
#define	GetD3DDevice()		(g_lpD3DDEV)

#define	IsWindowed()		(g_bWindowed)
#define	IsDepthBufferActive()	(g_bUseDepthBuffer)

#define	BGC_R	40
#define	BGC_G	40
#define	BGC_B	120

struct	TLVERTEX2D{
	float	x,y,z;
	float	rhw;
	D3DCOLOR	color;
	float	tu,tv;
};
#define	FVF_TLVERTEX2D	(D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)

struct	LVERTEX2D{
	float	x,y,z;
	float	rhw;
	D3DCOLOR	color;
};
#define	FVF_LVERTEX2D	(D3DFVF_XYZRHW|D3DFVF_DIFFUSE)
#endif